#!/usr/bin/perl

#this program takes the PPIs and their locations and
# for each gene
# counts how many PPIs it has on the Z and autosomes
#usage: perl PPIcounter.pl genelocations.txt PPis.txt

#e.g.: perl PPIcounter.pl BigTable_SmansoniCovLocation_NA.txt 6183.protein.links.v10.5_clean.txt 

my $loc = $ARGV[0];
my $list = $ARGV[1];

open (RESULTS, ">Sman_PPI_counts.txt");
print RESULTS "Gene Autocount Zcount Excludedcount NAcount TotalPPIs\n";


#2. let's make a hash of gene locations
open (LOC, "$loc") or die "where are the gene locations?"; 

while ($line2 = <LOC>) 
	{
	chomp $line2;
	($gene, $location)=split(/\t/, $line2);

	$loc{$gene} = $location; 
	
	}

#2. let's make an array of interactors for each gene

open (PPI, "$list") or die "where are the PPIs?"; 

while ($line = <PPI>) 
	{
	chomp $line;
	($aname, $bname, $score)=split(/\s/, $line);
	push(@{$ppis{$aname}}, $bname);
	push(@{$ppis{$bname}}, $aname);

	}

#3. Let's get unique interactors and count their locations

@genelist = keys %loc;

foreach $gene (@genelist)
	{
	$autocount=0;
	$Zcount=0;
	$NAcount=0;
	$excludedcount=0;
	$total=0;
	%hash=();
	@unique=();
	
	my %hash   = map {$_ => 1} @{$ppis{$gene}}; 
	my @unique = keys %hash;
	foreach $interact (@unique)
		{
		if ($loc{$interact} eq "Autosome")
			{
			$autocount=$autocount+1;
			}
		elsif ($loc{$interact} eq "Z")
			{
			$Zcount=$Zcount+1;
			}
		elsif (($loc{$interact} eq "Excluded") || ($loc{$gene} eq "Exluded"))
			{
			$excludedcount=$excludedcount+1;
			}
		elsif ($loc{$interact} eq "NA")
			{
			$NAcount=$NAcount+1;
			}
		else {}
		}
	$total=$autocount+$Zcount+$excludedcount+$NAcount;
	print RESULTS "$gene $autocount $Zcount $excludedcount $NAcount $total\n";

	}


