############
#Data table#
############

##Open data table##
table1 <- read.table("~/InputFile12_Proteomics1_Microarrays.txt",fill=TRUE,header=TRUE) # Enter here the pathway to your input table with imputed values
#table1 <- read.table("~/InputFile13_Proteomics2_Microarrays.txt",fill=TRUE,header=TRUE) # Enter here the pathway to your input table without imputed values
nrow(table1) #3050
head(table1) #19columns

##Subset F/M > 1 # Here you can exclude female biased genes
#table1_Gonads <- subset(table1, as.numeric(paste(FC_Gonads_MA)) < 1)
#nrow(table1_Gonads) #1223
#head(table1_Gonads) #19columns
#table1_Heads <- subset (table1, as.numeric(paste(FC_Heads_MA)) < 1)
#nrow(table1_Heads) #1373
#head(table1_Heads) #19columns

##Subset by STRINGENT strata##

#GONADS#
table2_Gonads <- subset(table1, UniqPept_Gonads=="no" & Log2_FC_Gonads_Prot!="n.a." & Log2_FC_Gonads_MA!="n.a." & Strata1_Stringent!="n.a." & Strata1_Stringent!="S1_jap") 
#table2_Gonads <- subset(table1_Gonads, UniqPept_Gonads=="no" & Log2_FC_Gonads_MA!="n.a." & Strata1_Stringent!="n.a." & Strata1_Stringent!="S1_jap") # Use this one if you filtered by F/M > 1 
nrow(table2_Gonads) #1313
head(table2_Gonads) #19columns

table2_Gonads_S0 <- subset(table2_Gonads, Strata1_Stringent=="S0")
table2_Gonads_S1_mans <- subset(table2_Gonads, Strata1_Stringent=="S1_mans")
table2_Gonads_Z <- subset(table2_Gonads, Strata1_Stringent=="S0" | Strata1_Stringent=="S1_mans")
table2_Gonads_PSA_shared <- subset(table2_Gonads, Strata1_Stringent=="PSA_shared")
table2_Gonads_Aut_shared <- subset(table2_Gonads, Strata1_Stringent=="Aut_shared")
head(table2_Gonads_Aut_shared)

nrow(table2_Gonads_S0) #72
nrow(table2_Gonads_S1_mans) #41
nrow(table2_Gonads_Z) #113
nrow(table2_Gonads_PSA_shared) #159
nrow(table2_Gonads_Aut_shared) #1041
 
#HEADS# 
table2_Heads <- subset(table1, UniqPept_Heads=="no" & Log2_FC_Heads_Prot!="n.a." & Log2_FC_Heads_MA!="n.a." & Strata1_Stringent!="n.a." & Strata1_Stringent!="S1_jap")
#table2_Heads <- subset(table1_Heads, UniqPept_Heads=="no" & Log2_FC_Heads_MA!="n.a." & Strata1_Stringent!="n.a." & Strata1_Stringent!="S1_jap") # Use this one if you filtered by F/M > 1 
nrow(table2_Heads) #934
head(table2_Heads) #19columns

table2_Heads_S0 <- subset(table2_Heads, Strata1_Stringent=="S0")
table2_Heads_S1_mans <- subset(table2_Heads, Strata1_Stringent=="S1_mans")
table2_Heads_Z <- subset(table2_Heads, Strata1_Stringent=="S0" | Strata1_Stringent=="S1_mans")
table2_Heads_PSA_shared <- subset(table2_Heads, Strata1_Stringent=="PSA_shared")
table2_Heads_Aut_shared <- subset(table2_Heads, Strata1_Stringent=="Aut_shared")

nrow(table2_Heads_S0) #56
nrow(table2_Heads_S1_mans) #32
nrow(table2_Heads_Z) #88
nrow(table2_Heads_PSA_shared) #108
nrow(table2_Heads_Aut_shared) #738


##Subset by EXHAUSTIVE strata##

#GONADS#
table2_Gonads <- subset(table1, UniqPept_Gonads=="no" &  Log2_FC_Gonads_Prot!="n.a." &  Log2_FC_Gonads_MA!="n.a." & Strata2_Exhaustive!="n.a." & Strata2_Exhaustive!="S1_jap") 
#table2_Gonads <- subset(table1_Gonads, UniqPept_Gonads=="no" &  Log2_FC_Gonads_Prot!="n.a." &  Log2_FC_Gonads_MA!="n.a." & Strata2_Exhaustive!="n.a." & Strata2_Exhaustive!="S1_jap") # Use this one if you filtered by F/M > 1 
nrow(table2_Gonads) #1363
head(table2_Gonads) #19columns

table2_Gonads_S0 <- subset(table2_Gonads, Strata2_Exhaustive=="S0")
table2_Gonads_S1_mans <- subset(table2_Gonads, Strata2_Exhaustive=="S1_mans")
table2_Gonads_Z <- subset(table2_Gonads, Strata2_Exhaustive=="S0" | Strata2_Exhaustive=="S1_mans")
table2_Gonads_PSA_shared <- subset(table2_Gonads, Strata2_Exhaustive=="PSA_shared")
table2_Gonads_Aut_shared <- subset(table2_Gonads, Strata2_Exhaustive=="Aut_shared")

nrow(table2_Gonads_S0) #100
nrow(table2_Gonads_S1_mans) #63
nrow(table2_Gonads_Z) #163
nrow(table2_Gonads_PSA_shared) #159
nrow(table2_Gonads_Aut_shared) #1041


#HEADS#
table2_Heads <- subset(table1, UniqPept_Heads=="no" & Log2_FC_Heads_Prot!="n.a." & Log2_FC_Heads_MA!="n.a." & Strata2_Exhaustive!="n.a." & Strata2_Exhaustive!="S1_jap")
#table2_Heads <- subset(table1_Heads, UniqPept_Heads=="no" & Log2_FC_Heads_Prot!="n.a." & Log2_FC_Heads_MA!="n.a." & Strata2_Exhaustive!="n.a." & Strata2_Exhaustive!="S1_jap") # Use this one if you filtered by F/M > 1 
nrow(table2_Heads) #929
head(table2_Heads) #19columns

table2_Heads_S0 <- subset(table2_Heads, Strata2_Exhaustive=="S0")
table2_Heads_S1_mans <- subset(table2_Heads, Strata2_Exhaustive=="S1_mans")
table2_Heads_Z <- subset(table2_Heads, Strata2_Exhaustive=="S0" | Strata2_Exhaustive=="S1_mans")
table2_Heads_PSA_shared <- subset(table2_Heads, Strata2_Exhaustive=="PSA_shared")
table2_Heads_Aut_shared <- subset(table2_Heads, Strata2_Exhaustive=="Aut_shared")

nrow(table2_Heads_S0) #74
nrow(table2_Heads_S1_mans) #49
nrow(table2_Heads_Z) #123
nrow(table2_Heads_PSA_shared) #108
nrow(table2_Heads_Aut_shared) #738

##########################
## Plots Z vs Autosomes ##
##########################

##HEADS##

#Microarrays#
#F:M 
boxplot(as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_MA)),as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_MA)), as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_MA)), names = c("Z","PSA","A"), ylab="log2(F:M)",ylim=c(-2,2), notch=T,cex.axis=1.2, cex.lab=1.5, outline = F, col=c("sienna2","gray40","gray20"), main="Microarrays - Heads")
abline(h=median(as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_MA))),lty=2,lwd=2,col="gray20")
median(as.numeric(paste(table2_Heads_Z$FC_Heads_MA)))
median(as.numeric(paste(table2_Heads_Aut_shared$FC_Heads_MA)))
median((as.numeric(paste(table2_Heads_Z$FC_Heads_MA))) / median(as.numeric(paste(table2_Heads_Aut_shared$FC_Heads_MA))))
wilcox.test(as.numeric(paste(table2_Heads_Z$FC_Heads_MA)),as.numeric(paste(table2_Heads_Aut_shared$FC_Heads_MA)))$p.value
median((as.numeric(paste(table2_Heads_PSA_shared$FC_Heads_MA))) / median(as.numeric(paste(table2_Heads_Aut_shared$FC_Heads_MA))))
wilcox.test(as.numeric(paste(table2_Heads_PSA_shared$FC_Heads_MA)),as.numeric(paste(table2_Heads_Aut_shared$FC_Heads_MA)))$p.value
#Female vs male
boxplot(log2(as.numeric(paste(table2_Heads_Z$Females_Heads_MA))), log2(as.numeric(paste(table2_Heads_Aut_shared$Females_Heads_MA))),log2(as.numeric(paste(table2_Heads_Z$Males_Heads_MA))), log2(as.numeric(paste(table2_Heads_Aut_shared$Males_Heads_MA))), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="Normalized Expression", notch=T, cex.axis=1.2, cex.lab=1.5, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="Microarrays - Heads")
median((as.numeric(paste(table2_Heads_Z$Females_Heads_MA))) / median(as.numeric(paste(table2_Heads_Aut_shared$Females_Heads_MA))))
wilcox.test(as.numeric(paste(table2_Heads_Z$Females_Heads_MA)),as.numeric(paste(table2_Heads_Aut_shared$Females_Heads_MA)))$p.value
median((as.numeric(paste(table2_Heads_Z$Males_Heads_MA))) / median(as.numeric(paste(table2_Heads_Aut_shared$Males_Heads_MA))))
wilcox.test(as.numeric(paste(table2_Heads_Z$Males_Heads_MA)),as.numeric(paste(table2_Heads_Aut_shared$Males_Heads_MA)))$p.value

#Proteomics#
#F:M
boxplot(as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot)), as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_Prot)), as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot)), names = c("Z","PSA","A"), ylab="log2(F:M)",ylim=c(-3.2,3.2), notch=T,cex.axis=1.2, cex.lab=1.5, outline = F, fill=TRUE, col=c("sienna2","gray40","gray20"), main="Proteomics - Heads")
abline(h=median(as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot))),lty=2,lwd=2,col="gray20")
median(2^as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot)))
median(2^as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot)))
(median(2^as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot)))) / (median(2^as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot))))
wilcox.test(2^as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot)),2^as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot)))$p.value
median(2^as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_Prot))) / median(2^as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot)))
wilcox.test(2^as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_Prot)),2^as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot)))$p.value
#Female vs male
boxplot(as.numeric(paste(table2_Heads_Z$Log2_Females_Heads_Prot)), as.numeric(paste(table2_Heads_Aut_shared$Log2_Females_Heads_Prot)),as.numeric(paste(table2_Heads_Z$Log2_Males_Heads_Prot)), as.numeric(paste(table2_Heads_Aut_shared$Log2_Males_Heads_Prot)), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="Log2 Normalized Expression", notch=T, cex.axis=1.2, cex.lab=1.5, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="Proteomics - Heads")
median(2^as.numeric(paste(table2_Heads_Z$Log2_Females_Heads_Prot))) / median(2^as.numeric(paste(table2_Heads_Aut_shared$Log2_Females_Heads_Prot)))
wilcox.test(2^as.numeric(paste(table2_Heads_Z$Log2_Females_Heads_Prot)),2^as.numeric(paste(table2_Heads_Aut_shared$Log2_Females_Heads_Prot)))$p.value
median(2^as.numeric(paste(table2_Heads_Z$Log2_Males_Heads_Prot))) / median(2^as.numeric(paste(table2_Heads_Aut_shared$Log2_Males_Heads_Prot)))
wilcox.test(2^as.numeric(paste(table2_Heads_Z$Log2_Males_Heads_Prot)),2^as.numeric(paste(table2_Heads_Aut_shared$Log2_Males_Heads_Prot)))$p.value

#Proteomics/microarrays# (Not shown)
#F:M 
boxplot((as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot))-as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_MA))),(as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_Prot))-as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_MA))),(as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot))-as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_MA))), names = c("Z","PSA","A"), ylab="log2(Prot/MicroA)",cex.axis=1.2, cex.lab=1.5, notch=T, outline = F, col=c("sienna2","gray40","gray20"), main="Prot/Microarrays - Heads")
abline(h=median(as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot))/as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_MA))),lty=2,lwd=2,col="gray20")

median(2^as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot)))/median(2^as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_MA)))
median(2^as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot)))/median(2^as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_MA)))
(median(2^as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot)))/median(2^as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_MA))))/(median(2^as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot)))/median(2^as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_MA))))
wilcox.test((2^as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot))/2^as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_MA))), (2^as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot))/2^as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_MA))))$p.value

##GONADS##

##Microarrays
#F:M
boxplot(as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_MA)),as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_MA)), as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_MA)), names = c("Z","PSA","A"), ylab="log2(F:M)",ylim=c(-3.2,3.2),cex.axis=1.2, cex.lab=1.5, notch=T, outline = F, col=c("sienna2","gray40","gray20"), main="Microarrays - Gonads")
abline(h=median(as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_MA))),lty=2,lwd=2,col="gray20")
wilcox.test(as.numeric(paste(table2_Gonads_Z$FC_Gonads_MA)),as.numeric(paste(table2_Gonads_Aut_shared$FC_Gonads_MA)))$p.value
median(as.numeric(paste(table2_Gonads_Z$FC_Gonads_MA))) / median(as.numeric(paste(table2_Gonads_Aut_shared$FC_Gonads_MA)))
median(as.numeric(paste(table2_Gonads_Z$FC_Gonads_MA)))
median(as.numeric(paste(table2_Gonads_Aut_shared$FC_Gonads_MA)))
wilcox.test(as.numeric(paste(table2_Gonads_PSA_shared$FC_Gonads_MA)),as.numeric(paste(table2_Gonads_Aut_shared$FC_Gonads_MA)))
median((as.numeric(paste(table2_Gonads_PSA_shared$FC_Gonads_MA))) / median(as.numeric(paste(table2_Gonads_Aut_shared$FC_Gonads_MA))))
#Female vs male
boxplot(log2(as.numeric(paste(table2_Gonads_Z$Females_Gonads_MA))), log2(as.numeric(paste(table2_Gonads_Aut_shared$Females_Gonads_MA))),log2(as.numeric(paste(table2_Gonads_Z$Males_Gonads_MA))), log2(as.numeric(paste(table2_Gonads_Aut_shared$Males_Gonads_MA))), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="Log2 Normalized Expression", notch=T, cex.axis=1.2, cex.lab=1.5, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="Microarrays - Gonads")
wilcox.test(as.numeric(paste(table2_Gonads_Z$Females_Gonads_MA)),as.numeric(paste(table2_Gonads_Aut_shared$Females_Gonads_MA)))$p.value
median((as.numeric(paste(table2_Gonads_Z$Females_Gonads_MA))) / median(as.numeric(paste(table2_Gonads_Aut_shared$Females_Gonads_MA))))
wilcox.test(as.numeric(paste(table2_Gonads_Z$Males_Gonads_MA)),as.numeric(paste(table2_Gonads_Aut_shared$Males_Gonads_MA)))$p.value
median((as.numeric(paste(table2_Gonads_Z$Males_Gonads_MA))) / median(as.numeric(paste(table2_Gonads_Aut_shared$Males_Gonads_MA))))

##Proteomics
#F:M
boxplot(as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_Prot)),as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_Prot)), as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_Prot)), names = c("Z","PSA","A"), ylab="log2(F:M)",cex.axis=1.2, cex.lab=1.5, notch=T, outline = F, col=c("sienna2","gray40","gray20"), main="Proteomics - Gonads")
abline(h=median(as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_Prot))),lty=2,lwd=2,col="gray20")
wilcox.test(2^as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_Prot)),2^as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_Prot)))$p.value
(median(2^as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_Prot))))/(median(2^as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_Prot))))
median(2^as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_Prot)))
median(2^as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_Prot)))
wilcox.test(2^as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_Prot)),2^as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_Prot)))$p.value
(median(2^as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_Prot))))/(median(2^as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_Prot))))
#Female vs male
boxplot(as.numeric(paste(table2_Gonads_Z$Log2_Females_Gonads_Prot)), as.numeric(paste(table2_Gonads_Aut_shared$Log2_Females_Gonads_Prot)),as.numeric(paste(table2_Gonads_Z$Log2_Males_Gonads_Prot)), as.numeric(paste(table2_Gonads_Aut_shared$Log2_Males_Gonads_Prot)), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="Log2 Normalized Expression", notch=T, cex.axis=1.2, cex.lab=1.5, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="Proteomics - Gonads")
wilcox.test(2^as.numeric(paste(table2_Gonads_Z$Log2_Females_Gonads_Prot)),2^as.numeric(paste(table2_Gonads_Aut_shared$Log2_Females_Gonads_Prot)))$p.value
median(2^as.numeric(paste(table2_Gonads_Z$Log2_Females_Gonads_Prot))) / median(2^as.numeric(paste(table2_Gonads_Aut_shared$Log2_Females_Gonads_Prot)))
wilcox.test(2^as.numeric(paste(table2_Gonads_Z$Log2_Males_Gonads_Prot)),2^as.numeric(paste(table2_Gonads_Aut_shared$Log2_Males_Gonads_Prot)))$p.value
median(2^as.numeric(paste(table2_Gonads_Z$Log2_Males_Gonads_Prot))) / median(2^as.numeric(paste(table2_Gonads_Aut_shared$Log2_Males_Gonads_Prot)))

###################
#Correlation Plots#
###################

##HEADS##
par(mfrow=c(1,1), mar=c(5,5,3,1))

nrow(table2_Heads_Aut_shared)
nrow(table2_Heads_PSA_shared)
nrow(table2_Heads_Z)

#F:M
#colFactor <- table2_Heads$Strata1_Stringent
colFactor <- table2_Heads$Strata2_Exhaustive
colF <- rep("antiquewhite2",length(colFactor)) ; colF[which(colFactor==("PSA_shared"))] <- "gray40" ; colF[which(colFactor==("Aut_shared"))] <- "gray20" ; colF[which(colFactor==("S0"))] <- "sienna2" ; colF[which(colFactor==("S1_mans"))] <- "sienna2"
colF

plot(as.numeric(paste(table2_Heads$Log2_FC_Heads_MA)),as.numeric(paste(table2_Heads$Log2_FC_Heads_Prot)), type="p", pch=16, col=colF, cex.axis=1.2, cex.lab=1.5,  xlim=c(-5,5), ylim=c(-8,8), xlab="log2(F:M) - Microarrays", ylab="log2(F:M) - Proteomics", main="Proteins & mRNAs correlation - HEADS")
abline(lm(as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot))~as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_MA)))$coefficients, col="gray20", lwd=2)
lm(as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot))~as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_MA)))$coefficients
abline(lm(as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_Prot))~as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_MA)))$coefficients, col="gray40",lwd=2)
lm(as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_Prot))~as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_MA)))$coefficients
abline(lm(as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot))~as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_MA)))$coefficients, col="sienna2", lwd=2)
lm(as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot))~as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_MA)))$coefficients
abline(h=0,lty=2)
abline(v=0,lty=2)
legend("bottomright",legend=c("A","PSA","Z"),col=c("gray20","gray40","sienna2"),lty=1,lwd=2,bty="n",cex=0.7)

#Females 
#colFactor <- table2_Heads$Strata1_Stringent
colFactor <- table2_Heads$Strata2_Exhaustive
colF <- rep("antiquewhite2",length(colFactor)) ; colF[which(colFactor==("PSA_shared"))] <- "gray40" ; colF[which(colFactor==("Aut_shared"))] <- "deeppink4" ; colF[which(colFactor==("S0"))] <- "deeppink2" ; colF[which(colFactor==("S1_mans"))] <- "deeppink2"
colF

plot(log2(as.numeric(paste(table2_Heads$Females_Heads_MA))),as.numeric(paste(table2_Heads$Log2_Females_Heads_Prot)), type="p", pch=16, col=colF, cex.axis=1.2, cex.lab=1.5, xlab="log2(Females) - Microarrays", ylab="log2(Females) - Proteomics", main="Female HEADS")
abline(lm(as.numeric(paste(table2_Heads_Aut_shared$Log2_Females_Heads_Prot))~log2(as.numeric(paste(table2_Heads_Aut_shared$Females_Heads_MA))))$coefficients, col="deeppink4", lwd=2)
lm(as.numeric(paste(table2_Heads_Aut_shared$Log2_Females_Heads_Prot))~log2(as.numeric(paste(table2_Heads_Aut_shared$Females_Heads_MA))))$coefficients
abline(lm(as.numeric(paste(table2_Heads_PSA_shared$Log2_Females_Heads_Prot))~log2(as.numeric(paste(table2_Heads_PSA_shared$Females_Heads_MA))))$coefficients, col="gray40",lwd=2)
lm(as.numeric(paste(table2_Heads_PSA_shared$Log2_Females_Heads_Prot))~log2(as.numeric(paste(table2_Heads_PSA_shared$Females_Heads_MA))))$coefficients
abline(lm(as.numeric(paste(table2_Heads_Z$Log2_Females_Heads_Prot))~log2(as.numeric(paste(table2_Heads_Z$Females_Heads_MA))))$coefficients, col="deeppink2", lwd=2)
lm(as.numeric(paste(table2_Heads_Z$Log2_Females_Heads_Prot))~log2(as.numeric(paste(table2_Heads_Z$Females_Heads_MA))))$coefficients
legend("bottomright",legend=c("A","PSA","Z"),col=c("deeppink4","gray40","deeppink2"),lty=1,lwd=2,bty="n",cex=0.7)

#Males 
#colFactor <- table2_Heads$Strata1_Stringent
colFactor <- table2_Heads$Strata2_Exhaustive
colF <- rep("antiquewhite2",length(colFactor)) ; colF[which(colFactor==("PSA_shared"))] <- "gray40" ; colF[which(colFactor==("Aut_shared"))] <- "royalblue4" ; colF[which(colFactor==("S0"))] <- "royalblue2" ; colF[which(colFactor==("S1_mans"))] <- "royalblue2"
colF

plot(log2(as.numeric(paste(table2_Heads$Males_Heads_MA))),as.numeric(paste(table2_Heads$Log2_Males_Heads_Prot)), type="p", pch=16, col=colF, cex.axis=1.2, cex.lab=1.5, xlab="log2(Male) - Microarrays", ylab="log2(Male) - Proteomics", main="Male HEADS")
abline(lm(as.numeric(paste(table2_Heads_Aut_shared$Log2_Males_Heads_Prot))~log2(as.numeric(paste(table2_Heads_Aut_shared$Males_Heads_MA))))$coefficients, col="royalblue4", lwd=2)
lm(as.numeric(paste(table2_Heads_Aut_shared$Log2_Males_Heads_Prot))~log2(as.numeric(paste(table2_Heads_Aut_shared$Males_Heads_MA))))$coefficients
abline(lm(as.numeric(paste(table2_Heads_PSA_shared$Log2_Males_Heads_Prot))~log2(as.numeric(paste(table2_Heads_PSA_shared$Males_Heads_MA))))$coefficients, col="gray40",lwd=2)
lm(as.numeric(paste(table2_Heads_PSA_shared$Log2_Males_Heads_Prot))~log2(as.numeric(paste(table2_Heads_PSA_shared$Males_Heads_MA))))$coefficients
abline(lm(as.numeric(paste(table2_Heads_Z$Log2_Males_Heads_Prot))~log2(as.numeric(paste(table2_Heads_Z$Males_Heads_MA))))$coefficients, col="royalblue2", lwd=2)
lm(as.numeric(paste(table2_Heads_Z$Log2_Males_Heads_Prot))~log2(as.numeric(paste(table2_Heads_Z$Males_Heads_MA))))$coefficients
legend("bottomright",legend=c("A","PSA","Z"),col=c("royalblue4","gray40","royalblue2"),lty=1,lwd=2,bty="n",cex=0.7)

##GONADS##
par(mfrow=c(1,1), mar=c(5,5,3,1))

nrow(table2_Gonads_Aut_shared)
nrow(table2_Gonads_PSA_shared)
nrow(table2_Gonads_Z)

#colFactor <- table2_Gonads$Strata1_Stringent
colFactor <- table2_Gonads$Strata2_Exhaustive
colF <- rep("antiquewhite2",length(colFactor)) ; colF[which(colFactor==("PSA_shared"))] <- "gray40" ; colF[which(colFactor==("Aut_shared"))] <- "gray20" ; colF[which(colFactor==("S0"))] <- "sienna2" ; colF[which(colFactor==("S1_mans"))] <- "sienna2"
colF

#F:M
plot(as.numeric(paste(table2_Gonads$Log2_FC_Gonads_MA)),as.numeric(paste(table2_Gonads$Log2_FC_Gonads_Prot)), type="p", pch=16, col=colF, cex.axis=1.2, cex.lab=1.5, xlim=c(-11,8), ylim=c(-8,8), xlab="log2(F:M) - Microarrays", ylab="log2(F:M) - Proteomics", main="Proteins & mRNAs correlation  - GONADS")
abline(lm(as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_Prot))~as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_MA)))$coefficients, col="gray20", lwd=2)
lm(as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_Prot))~as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_MA)))$coefficients
abline(lm(as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_Prot))~as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_MA)))$coefficients, col="gray40",lwd=2)
lm(as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_Prot))~as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_MA)))$coefficients
abline(lm(as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_Prot))~as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_MA)))$coefficients, col="sienna2", lwd=2)
lm(as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_Prot))~as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_MA)))$coefficients
abline(h=0,lty=2)
abline(v=0,lty=2)
text(vfont=0.1)
legend("bottomright",legend=c("A","PSA","Z"),col=c("gray20","gray40","sienna2"),lty=1,lwd=2,bty="n",cex=0.7)

#Females 
#colFactor <- table2_Gonads$Strata1_Stringent
colFactor <- table2_Gonads$Strata2_Exhaustive
colF <- rep("antiquewhite2",length(colFactor)) ; colF[which(colFactor==("PSA_shared"))] <- "gray40" ; colF[which(colFactor==("Aut_shared"))] <- "deeppink4" ; colF[which(colFactor==("S0"))] <- "deeppink2" ; colF[which(colFactor==("S1_mans"))] <- "deeppink2"
colF

plot(log2(as.numeric(paste(table2_Gonads$Females_Gonads_MA))),as.numeric(paste(table2_Gonads$Log2_Females_Gonads_Prot)), type="p", pch=16, col=colF, cex.axis=1.2, cex.lab=1.5, xlab="log2(Females) - Microarrays", ylab="log2(Females) - Proteomics", main="Female GONADS")
abline(lm(as.numeric(paste(table2_Gonads_Aut_shared$Log2_Females_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_Aut_shared$Females_Gonads_MA))))$coefficients, col="deeppink4", lwd=2)
lm(as.numeric(paste(table2_Gonads_Aut_shared$Log2_Females_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_Aut_shared$Females_Gonads_MA))))$coefficients
abline(lm(as.numeric(paste(table2_Gonads_PSA_shared$Log2_Females_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_PSA_shared$Females_Gonads_MA))))$coefficients, col="gray40",lwd=2)
lm(as.numeric(paste(table2_Gonads_PSA_shared$Log2_Females_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_PSA_shared$Females_Gonads_MA))))$coefficients
abline(lm(as.numeric(paste(table2_Gonads_Z$Log2_Females_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_Z$Females_Gonads_MA))))$coefficients, col="deeppink2", lwd=2)
lm(as.numeric(paste(table2_Gonads_Z$Log2_Females_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_Z$Females_Gonads_MA))))$coefficients
legend("bottomright",legend=c("A","PSA","Z"),col=c("deeppink4","gray40","deeppink2"),lty=1,lwd=2,bty="n",cex=0.7)

#Males 
#colFactor <- table2_Gonads$Strata1_Stringent
colFactor <- table2_Gonads$Strata2_Exhaustive
colF <- rep("antiquewhite2",length(colFactor)) ; colF[which(colFactor==("PSA_shared"))] <- "gray40" ; colF[which(colFactor==("Aut_shared"))] <- "royalblue4" ; colF[which(colFactor==("S0"))] <- "royalblue2" ; colF[which(colFactor==("S1_mans"))] <- "royalblue2"
colF

plot(log2(as.numeric(paste(table2_Gonads$Males_Gonads_MA))),as.numeric(paste(table2_Gonads$Log2_Males_Gonads_Prot)), type="p", pch=16, col=colF, cex.axis=1.2, cex.lab=1.5, xlab="log2(Male) - Microarrays", ylab="log2(Male) - Proteomics", main="Male GONADS")
abline(lm(as.numeric(paste(table2_Gonads_Aut_shared$Log2_Males_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_Aut_shared$Males_Gonads_MA))))$coefficients, col="royalblue4", lwd=2)
lm(as.numeric(paste(table2_Gonads_Aut_shared$Log2_Males_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_Aut_shared$Males_Gonads_MA))))$coefficients
abline(lm(as.numeric(paste(table2_Gonads_PSA_shared$Log2_Males_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_PSA_shared$Males_Gonads_MA))))$coefficients, col="gray40",lwd=2)
lm(as.numeric(paste(table2_Gonads_PSA_shared$Log2_Males_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_PSA_shared$Males_Gonads_MA))))$coefficients
abline(lm(as.numeric(paste(table2_Gonads_Z$Log2_Males_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_Z$Males_Gonads_MA))))$coefficients, col="royalblue2", lwd=2)
lm(as.numeric(paste(table2_Gonads_Z$Log2_Males_Gonads_Prot))~log2(as.numeric(paste(table2_Gonads_Z$Males_Gonads_MA))))$coefficients
legend("bottomright",legend=c("A","PSA","Z"),col=c("royalblue4","gray40","royalblue2"),lty=1,lwd=2,bty="n",cex=0.7)


####################
#HEADS: Correlation#
####################

#F:M
nrow(table2_Heads_Z)
cor(as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_MA)),as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot)),use = "everything",method = c("pearson"))
cor.test(as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_MA)),as.numeric(paste(table2_Heads_Z$Log2_FC_Heads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Heads_Aut_shared)
cor(as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_MA)),as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot)),use = "everything",method = c("pearson"))
cor.test(as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_MA)),as.numeric(paste(table2_Heads_Aut_shared$Log2_FC_Heads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Heads_PSA_shared)
cor(as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_MA)),as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_Prot)),use = "everything",method = c("pearson"))
cor.test(as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_MA)),as.numeric(paste(table2_Heads_PSA_shared$Log2_FC_Heads_Prot)),use = "everything",method = c("pearson"))$p.value

nrow(table2_Heads)
cor(as.numeric(paste(table2_Heads$Log2_FC_Heads_MA)),as.numeric(paste(table2_Heads$Log2_FC_Heads_Prot)),use = "everything",method = c("pearson"))
cor.test(as.numeric(paste(table2_Heads$Log2_FC_Heads_MA)),as.numeric(paste(table2_Heads$Log2_FC_Heads_Prot)),use = "everything",method = c("pearson"))$p.value

#Females
nrow(table2_Heads_Z)
cor(log2(as.numeric(paste(table2_Heads_Z$Females_Heads_MA))),as.numeric(paste(table2_Heads_Z$Log2_Females_Heads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Heads_Z$Females_Heads_MA))),as.numeric(paste(table2_Heads_Z$Log2_Females_Heads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Heads_Aut_shared)
cor(log2(as.numeric(paste(table2_Heads_Aut_shared$Females_Heads_MA))),as.numeric(paste(table2_Heads_Aut_shared$Log2_Females_Heads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Heads_Aut_shared$Females_Heads_MA))),as.numeric(paste(table2_Heads_Aut_shared$Log2_Females_Heads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Heads_PSA_shared)
cor(log2(as.numeric(paste(table2_Heads_PSA_shared$Females_Heads_MA))),as.numeric(paste(table2_Heads_PSA_shared$Log2_Females_Heads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Heads_PSA_shared$Females_Heads_MA))),as.numeric(paste(table2_Heads_PSA_shared$Log2_Females_Heads_Prot)),use = "everything",method = c("pearson"))$p.value

#Males
nrow(table2_Heads_Z)
cor(log2(as.numeric(paste(table2_Heads_Z$Males_Heads_MA))),as.numeric(paste(table2_Heads_Z$Log2_Males_Heads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Heads_Z$Males_Heads_MA))),as.numeric(paste(table2_Heads_Z$Log2_Males_Heads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Heads_Aut_shared)
cor(log2(as.numeric(paste(table2_Heads_Aut_shared$Males_Heads_MA))),as.numeric(paste(table2_Heads_Aut_shared$Log2_Males_Heads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Heads_Aut_shared$Males_Heads_MA))),as.numeric(paste(table2_Heads_Aut_shared$Log2_Males_Heads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Heads_PSA_shared)
cor(log2(as.numeric(paste(table2_Heads_PSA_shared$Males_Heads_MA))),as.numeric(paste(table2_Heads_PSA_shared$Log2_Males_Heads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Heads_PSA_shared$Males_Heads_MA))),as.numeric(paste(table2_Heads_PSA_shared$Log2_Males_Heads_Prot)),use = "everything",method = c("pearson"))$p.value


#####################
#GONADS: Correlation#
#####################

#F:M
nrow(table2_Gonads_Z)
cor(as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_MA)),as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_Prot)),use = "everything",method = c("pearson"))
cor.test(as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_MA)),as.numeric(paste(table2_Gonads_Z$Log2_FC_Gonads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Gonads_Aut_shared)
cor(as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_MA)),as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_Prot)),use = "everything",method = c("pearson"))
cor.test(as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_MA)),as.numeric(paste(table2_Gonads_Aut_shared$Log2_FC_Gonads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Gonads_PSA_shared)
cor(as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_MA)),as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_Prot)),use = "everything",method = c("pearson"))
cor.test(as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_MA)),as.numeric(paste(table2_Gonads_PSA_shared$Log2_FC_Gonads_Prot)),use = "everything",method = c("pearson"))$p.value

nrow(table2_Gonads)
cor(as.numeric(paste(table2_Gonads$Log2_FC_Gonads_MA)),as.numeric(paste(table2_Gonads$Log2_FC_Gonads_Prot)),use = "everything",method = c("pearson"))
cor.test(as.numeric(paste(table2_Gonads$Log2_FC_Gonads_MA)),as.numeric(paste(table2_Gonads$Log2_FC_Gonads_Prot)),use = "everything",method = c("pearson"))$p.value

#Females
nrow(table2_Gonads_Z)
table2_Gonads_Z
cor(log2(as.numeric(paste(table2_Gonads_Z$Females_Gonads_MA))),as.numeric(paste(table2_Gonads_Z$Log2_Females_Gonads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Gonads_Z$Females_Gonads_MA))),as.numeric(paste(table2_Gonads_Z$Log2_Females_Gonads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Gonads_Aut_shared)
cor(log2(as.numeric(paste(table2_Gonads_Aut_shared$Females_Gonads_MA))),as.numeric(paste(table2_Gonads_Aut_shared$Log2_Females_Gonads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Gonads_Aut_shared$Females_Gonads_MA))),as.numeric(paste(table2_Gonads_Aut_shared$Log2_Females_Gonads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Gonads_PSA_shared)
cor(log2(as.numeric(paste(table2_Gonads_PSA_shared$Females_Gonads_MA))),as.numeric(paste(table2_Gonads_PSA_shared$Log2_Females_Gonads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Gonads_PSA_shared$Females_Gonads_MA))),as.numeric(paste(table2_Gonads_PSA_shared$Log2_Females_Gonads_Prot)),use = "everything",method = c("pearson"))$p.value

#Males
nrow(table2_Gonads_Z)
table2_Gonads_Z
cor(log2(as.numeric(paste(table2_Gonads_Z$Males_Gonads_MA))),as.numeric(paste(table2_Gonads_Z$Log2_Males_Gonads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Gonads_Z$Males_Gonads_MA))),as.numeric(paste(table2_Gonads_Z$Log2_Males_Gonads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Gonads_Aut_shared)
cor(log2(as.numeric(paste(table2_Gonads_Aut_shared$Males_Gonads_MA))),as.numeric(paste(table2_Gonads_Aut_shared$Log2_Males_Gonads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Gonads_Aut_shared$Males_Gonads_MA))),as.numeric(paste(table2_Gonads_Aut_shared$Log2_Males_Gonads_Prot)),use = "everything",method = c("pearson"))$p.value
nrow(table2_Gonads_PSA_shared)
cor(log2(as.numeric(paste(table2_Gonads_PSA_shared$Males_Gonads_MA))),as.numeric(paste(table2_Gonads_PSA_shared$Log2_Males_Gonads_Prot)),use = "everything",method = c("pearson"))
cor.test(log2(as.numeric(paste(table2_Gonads_PSA_shared$Males_Gonads_MA))),as.numeric(paste(table2_Gonads_PSA_shared$Log2_Males_Gonads_Prot)),use = "everything",method = c("pearson"))$p.value

