#############
#A. RAW DATA#
#############

# Open data table
table1 <- read.table("/Users/MarionPic/Dropbox/SchistoZ_Revisions1/Marion_Ongoing/InputFile7_Transcriptomics1.txt",fill=TRUE,header=TRUE) # To work with one-to-one blat orthologs orthologs
#table1 <- read.table("~/InputFile10_Transcriptomics2.txt",fill=TRUE,header=TRUE) # To work with WormDB orthologs
nrow(table1) #7382

## OVERALL EXPRESSION PLOTS

# Schistosomula - plot overall expression per samples
boxplot(table1$Jap_F_Som_1_RPKM, table1$Jap_F_Som_2_RPKM, table1$Jap_F_Som_3_RPKM, table1$Jap_M_Som_1_RPKM, table1$Jap_M_Som_2_RPKM, table1$Jap_M_Som_3_RPKM, table1$Mans_F_Som_1_RPKM, table1$Mans_F_Som_2_RPKM, table1$Mans_M_Som_1_RPKM, table1$Mans_M_Som_2_RPKM, names = c("F1","F2","F3","M1","M2","M3","F1","F2","M1","M2"), col=c("deeppink3","deeppink3","deeppink3","royalblue3","royalblue3","royalblue3","deeppink3","deeppink3","royalblue3","royalblue3"),notch=T, outline = F)
totaldata_Som <- as.numeric(paste(c(table1$Jap_F_Som_1_RPKM, table1$Jap_F_Som_2_RPKM, table1$Jap_F_Som_3_RPKM, table1$Jap_M_Som_1_RPKM, table1$Jap_M_Som_2_RPKM, table1$Jap_M_Som_3_RPKM, table1$Mans_F_Som_1_RPKM, table1$Mans_F_Som_2_RPKM, table1$Mans_M_Som_1_RPKM, table1$Mans_M_Som_2_RPKM)))
median_Som <- median(totaldata_Som,na.rm=T)
median_Som
abline(h=median_Som, lty=2, lwd=1, col="black")

# Adults - plot overall expression per samples
boxplot(table1$Jap_F_Ad_1_RPKM, table1$Jap_F_Ad_2_RPKM, table1$Jap_F_Ad_3_RPKM, table1$Jap_M_Ad_1_RPKM, table1$Jap_M_Ad_2_RPKM, table1$Jap_M_Ad_3_RPKM,table1$Mans_F_Ad_2_RPKM, table1$Mans_F_Ad_3_RPKM, table1$Mans_M_Ad_1_RPKM, table1$Mans_M_Ad_3_RPKM, names = c("F1","F2","F3","M1","M2","M3","F1","F2","M1","M2"), col=c("deeppink3","deeppink3","deeppink3","royalblue3","royalblue3","royalblue3","deeppink3","deeppink3","royalblue3","royalblue3"),notch=T, outline = F)
totaldata_Ad <- as.numeric(paste(c(table1$Jap_F_Ad_1_RPKM, table1$Jap_F_Ad_2_RPKM, table1$Jap_F_Ad_3_RPKM, table1$Jap_M_Ad_1_RPKM, table1$Jap_M_Ad_2_RPKM, table1$Jap_M_Ad_3_RPKM,table1$Mans_F_Ad_1_RPKM, table1$Mans_F_Ad_2_RPKM, table1$Mans_F_Ad_3_RPKM, table1$Mans_M_Ad_1_RPKM, table1$Mans_M_Ad_2_RPKM, table1$Mans_M_Ad_3_RPKM)))
median_Ad <- median(totaldata_Ad,na.rm=T)
median_Ad
abline(h=median_Ad, lty=2, lwd=1, col="black")

## CORRELATION ANALYSIS

library(gplots)

# Schistosomula - correlation 
Table_cor_Som <- (subset(table1, select= c("Jap_F_Som_1_RPKM", "Jap_F_Som_2_RPKM", "Jap_F_Som_3_RPKM", "Jap_M_Som_1_RPKM", "Jap_M_Som_2_RPKM", "Jap_M_Som_3_RPKM", "Mans_F_Som_1_RPKM", "Mans_F_Som_2_RPKM", "Mans_M_Som_1_RPKM", "Mans_M_Som_2_RPKM")))
colors_cor_Som <- c("gray","gray","gray","black","black","black","antiquewhite2","antiquewhite2","antiquewhite4","antiquewhite4")
heatmap.2(cor(Table_cor_Som,method="pearson"),col=colorRampPalette(c("blue","white","red","firebrick4"))(15),ColSideColors = colors_cor_Som,scale="none",symm=T,margins=c(15,15),key=T,trace="none")
legend("topright",legend=c("Male S.mans","Fem S.mans","Fem S.jap","Male S.jap"),col=c("antiquewhite4","antiquewhite2","gray","black"),lty=1,lwd=10)

# Adults - correlation (Before exclusion of ERR506076 and ERR506082)
Table_cor_Ad <- (subset(table1, select= c("Jap_F_Ad_1_RPKM", "Jap_F_Ad_2_RPKM", "Jap_F_Ad_3_RPKM", "Jap_M_Ad_1_RPKM", "Jap_M_Ad_2_RPKM", "Jap_M_Ad_3_RPKM", "Mans_F_Ad_1_RPKM", "Mans_F_Ad_2_RPKM", "Mans_F_Ad_3_RPKM", "Mans_M_Ad_1_RPKM", "Mans_M_Ad_2_RPKM", "Mans_M_Ad_3_RPKM")))
colors_cor_Ad <- c("gray","gray","gray","black","black","black","antiquewhite2","antiquewhite2","antiquewhite2","antiquewhite4","antiquewhite4","antiquewhite4")
heatmap.2(cor(Table_cor_Ad,method="pearson"),col=colorRampPalette(c("blue","white","red","firebrick4"))(15),ColSideColors = colors_cor_Ad,scale="none",symm=T,margins=c(15,15),key=T,trace="none")
legend("topright",legend=c("Fem S.mans","Male S.mans","Fem S.jap","Male S.jap"),col=c("antiquewhite2","antiquewhite4","gray","black"),lty=1,lwd=10)

# Adults - correlation (After exclusion of ERR506076 and ERR506082)
Table_cor_Ad <- (subset(table1, select= c("Jap_F_Ad_1_RPKM", "Jap_F_Ad_2_RPKM", "Jap_F_Ad_3_RPKM", "Jap_M_Ad_1_RPKM", "Jap_M_Ad_2_RPKM", "Jap_M_Ad_3_RPKM", "Mans_F_Ad_2_RPKM", "Mans_F_Ad_3_RPKM", "Mans_M_Ad_1_RPKM", "Mans_M_Ad_3_RPKM")))
colors_cor_Ad <- c("gray","gray","gray","black","black","black","antiquewhite2","antiquewhite2","antiquewhite4","antiquewhite4")
heatmap.2(cor(Table_cor_Ad,method="pearson"),col=colorRampPalette(c("blue","white","red","firebrick4"))(15),ColSideColors = colors_cor_Ad,scale="none",symm=T,margins=c(15,15),key=T,trace="none")
legend("topright",legend=c("Fem S.mans","Male S.mans","Fem S.jap","Male S.jap"),col=c("antiquewhite2","antiquewhite4","gray","black"),lty=1,lwd=10)


########################
#B. LOESS NORMALIZATION#
########################

library(affy)

# Prepare information table
Gene_Characteristics <- subset(table1, select = c("Gene_ID_mans","Chrom_loc_GFF_mans","First_Base_GFF_mans", "Gene_length_GFF_mans", "Loc_cov_mans", "BlatHomolog_ID_jap", "Scaffold_ID_GFF_jap", "First_Base_GFF_jap", "Gene_length_GFF_jap", "Strata1_Stringent","Strata2_Exhaustive"))

# Schistosomula - Expression table without null data
table1_wo0_Som <- 0.000001 + (subset(table1, select = c("Jap_F_Som_1_RPKM", "Jap_F_Som_2_RPKM", "Jap_F_Som_3_RPKM", "Jap_M_Som_1_RPKM", "Jap_M_Som_2_RPKM", "Jap_M_Som_3_RPKM","Mans_F_Som_1_RPKM", "Mans_F_Som_2_RPKM", "Mans_M_Som_1_RPKM","Mans_M_Som_2_RPKM")))
nrow(table1_wo0_Som)
tableSom_normalized <- normalize.loess(table1_wo0_Som)
tableSom_normalized <- as.data.frame(tableSom_normalized)
nrow(tableSom_normalized)
Jap_Som_F1 <- (tableSom_normalized[,1])
Jap_Som_F2 <- (tableSom_normalized[,2])
Jap_Som_F3 <- (tableSom_normalized[,3])
Jap_Som_M1 <- (tableSom_normalized[,4])
Jap_Som_M2 <- (tableSom_normalized[,5])
Jap_Som_M3 <- (tableSom_normalized[,6])
Mans_Som_F1 <- (tableSom_normalized[,7])
Mans_Som_F2 <- (tableSom_normalized[,8])
Mans_Som_M1 <- (tableSom_normalized[,9])
Mans_Som_M2 <- (tableSom_normalized[,10])

# Adults - Expression table without null data
table1_wo0_Ad <- 0.000001 + (subset(table1, select= c("Jap_F_Ad_1_RPKM", "Jap_F_Ad_2_RPKM", "Jap_F_Ad_3_RPKM", "Jap_M_Ad_1_RPKM", "Jap_M_Ad_2_RPKM", "Jap_M_Ad_3_RPKM","Mans_F_Ad_2_RPKM", "Mans_F_Ad_3_RPKM", "Mans_M_Ad_1_RPKM", "Mans_M_Ad_3_RPKM")))
nrow(table1_wo0_Ad)
tableAd_normalized <- normalize.loess(table1_wo0_Ad)
tableAd_normalized <- as.data.frame(tableAd_normalized)
nrow(tableAd_normalized)
Jap_Ad_F1 <- (tableAd_normalized[,1])
Jap_Ad_F2 <- (tableAd_normalized[,2])
Jap_Ad_F3 <- (tableAd_normalized[,3])
Jap_Ad_M1 <- (tableAd_normalized[,4])
Jap_Ad_M2 <- (tableAd_normalized[,5])
Jap_Ad_M3 <- (tableAd_normalized[,6])
Mans_Ad_F1 <- (tableAd_normalized[,7]) # From here ERR506083 will be Mans_Ad_F1 (exclusion of non-correlated ERR506076 library)
Mans_Ad_F2 <- (tableAd_normalized[,8]) # From here ERR506084 will be Mans_Ad_F2 (exclusion of non-correlated ERR506076 library)
Mans_Ad_M1 <- (tableAd_normalized[,9])
Mans_Ad_M2 <- (tableAd_normalized[,10]) # From here ERR506090 will be Mans_Ad_M2 (exclusion of non-correlated ERR506082 library)

# Normalization with all stages - Expression table without null data
table1_wo0 <- 0.000001 + (subset(table1, select= c("Jap_F_Som_1_RPKM", "Jap_F_Som_2_RPKM", "Jap_F_Som_3_RPKM", "Jap_M_Som_1_RPKM", "Jap_M_Som_2_RPKM", "Jap_M_Som_3_RPKM","Mans_F_Som_1_RPKM", "Mans_F_Som_2_RPKM", "Mans_M_Som_1_RPKM","Mans_M_Som_2_RPKM","Jap_F_Ad_1_RPKM", "Jap_F_Ad_2_RPKM", "Jap_F_Ad_3_RPKM", "Jap_M_Ad_1_RPKM", "Jap_M_Ad_2_RPKM", "Jap_M_Ad_3_RPKM","Mans_F_Ad_2_RPKM", "Mans_F_Ad_3_RPKM", "Mans_M_Ad_1_RPKM", "Mans_M_Ad_3_RPKM")))
nrow(table1_wo0)
table_normalized <- normalize.loess(table1_wo0)
table_normalized <- as.data.frame(table_normalized)
nrow(table_normalized)
Jap_Som_F1 <- (table_normalized[,1])
Jap_Som_F2 <- (table_normalized[,2])
Jap_Som_F3 <- (table_normalized[,3])
Jap_Som_M1 <- (table_normalized[,4])
Jap_Som_M2 <- (table_normalized[,5])
Jap_Som_M3 <- (table_normalized[,6])
Mans_Som_F1 <- (table_normalized[,7])
Mans_Som_F2 <- (table_normalized[,8])
Mans_Som_M1 <- (table_normalized[,9])
Mans_Som_M2 <- (table_normalized[,10])

Jap_Ad_F1 <- (table_normalized[,11])
Jap_Ad_F2 <- (table_normalized[,12])
Jap_Ad_F3 <- (table_normalized[,13])
Jap_Ad_M1 <- (table_normalized[,14])
Jap_Ad_M2 <- (table_normalized[,15])
Jap_Ad_M3 <- (table_normalized[,16])
Mans_Ad_F1 <- (table_normalized[,17]) # From here ERR506083 will be Mans_Ad_F1 (exclusion of non-correlated ERR506076 library)
Mans_Ad_F2 <- (table_normalized[,18]) # From here ERR506084 will be Mans_Ad_F2 (exclusion of non-correlated ERR506076 library)
Mans_Ad_M1 <- (table_normalized[,19])
Mans_Ad_M2 <- (table_normalized[,20]) # From here ERR506090 will be Mans_Ad_M2 (exclusion of non-correlated ERR506082 library)

#Print SuperTable_normalized
SuperTable_normalized <- cbind(Gene_Characteristics, Jap_Som_F1,Jap_Som_F2,Jap_Som_F3,Jap_Som_M1,Jap_Som_M2,Jap_Som_M3,Jap_Ad_F1,Jap_Ad_F2,Jap_Ad_F3,Jap_Ad_M1,Jap_Ad_M2,Jap_Ad_M3,Mans_Som_F1,Mans_Som_F2,Mans_Som_M1,Mans_Som_M2,Mans_Ad_F1,Mans_Ad_F2,Mans_Ad_M1,Mans_Ad_M2)
head(SuperTable_normalized)
nrow(SuperTable_normalized)
write.table(SuperTable_normalized,file="~/InputFileXXX_SuperTableNormalized_TranscriptomicsXXX") # Change depending on analyzed data

## OVERALL EXPRESSION PLOTS

layout(matrix(c(1), 1, 1, byrow = TRUE))
par(mar=c(3,5,3,1))

# Schistosomula - Plot overall expression per samples 
boxplot(SuperTable_normalized$Jap_Som_F1, SuperTable_normalized$Jap_Som_F2, SuperTable_normalized$Jap_Som_F3, SuperTable_normalized$Jap_Som_M1, SuperTable_normalized$Jap_Som_M2, SuperTable_normalized$Jap_Som_M3, SuperTable_normalized$Mans_Som_F1, SuperTable_normalized$Mans_Som_F2, SuperTable_normalized$Mans_Som_M1, SuperTable_normalized$Mans_Som_M2, names = c("F1","F2","F3","M1","M2","M3","F1","F2","M1","M2"), col=c("deeppink3","deeppink3","deeppink3","royalblue3","royalblue3","royalblue3","deeppink3","deeppink3","royalblue3","royalblue3"),notch=T, outline = F)
totaldata_Som <- as.numeric(paste(c(SuperTable_normalized$Jap_Som_F1, SuperTable_normalized$Jap_Som_F2, SuperTable_normalized$Jap_Som_F3, SuperTable_normalized$Jap_Som_M1, SuperTable_normalized$Jap_Som_M2, SuperTable_normalized$Jap_Som_M3, SuperTable_normalized$Mans_Som_F1, SuperTable_normalized$Mans_Som_F2, SuperTable_normalized$Mans_Som_M1, SuperTable_normalized$Mans_Som_M2)))
median_Som <- median(totaldata_Som,na.rm=T)
median_Som
abline(h=median_Som, lty=2, lwd=1, col="black")

# Adults - Plot overall expression per samples 
boxplot(SuperTable_normalized$Jap_Ad_F1, SuperTable_normalized$Jap_Ad_F2, SuperTable_normalized$Jap_Ad_F3, SuperTable_normalized$Jap_Ad_M1, SuperTable_normalized$Jap_Ad_M2, SuperTable_normalized$Jap_Ad_M3,SuperTable_normalized$Mans_Ad_F1, SuperTable_normalized$Mans_Ad_F2, SuperTable_normalized$Mans_Ad_M1, SuperTable_normalized$Mans_Ad_M2, names = c("F1","F2","F3","M1","M2","M3","F1","F2","M1","M2"), col=c("deeppink3","deeppink3","deeppink3","royalblue3","royalblue3","royalblue3","deeppink3","deeppink3","royalblue3","royalblue3"),notch=T, outline = F)
totaldata_Ad <- as.numeric(paste(c(SuperTable_normalized$Jap_Ad_F1, SuperTable_normalized$Jap_Ad_F2, SuperTable_normalized$Jap_Ad_F3, SuperTable_normalized$Jap_Ad_M1, SuperTable_normalized$Jap_Ad_M2, SuperTable_normalized$Jap_Ad_M3,SuperTable_normalized$Mans_Ad_F1, SuperTable_normalized$Mans_Ad_F2, SuperTable_normalized$Mans_Ad_M1, SuperTable_normalized$Mans_Ad_M2)))
median_Ad <- median(totaldata_Ad,na.rm=T)
median_Ad
abline(h=median_Ad, lty=2, lwd=1, col="black")

# All stages - Plot overall expression per samples 
boxplot(SuperTable_normalized$Jap_Som_F1, SuperTable_normalized$Jap_Som_F2, SuperTable_normalized$Jap_Som_F3, SuperTable_normalized$Jap_Som_M1, SuperTable_normalized$Jap_Som_M2, SuperTable_normalized$Jap_Som_M3, SuperTable_normalized$Mans_Som_F1, SuperTable_normalized$Mans_Som_F2, SuperTable_normalized$Mans_Som_M1, SuperTable_normalized$Mans_Som_M2,SuperTable_normalized$Jap_Ad_F1, SuperTable_normalized$Jap_Ad_F2, SuperTable_normalized$Jap_Ad_F3, SuperTable_normalized$Jap_Ad_M1, SuperTable_normalized$Jap_Ad_M2, SuperTable_normalized$Jap_Ad_M3,SuperTable_normalized$Mans_Ad_F1, SuperTable_normalized$Mans_Ad_F2, SuperTable_normalized$Mans_Ad_M1, SuperTable_normalized$Mans_Ad_M2, names = c("F1","F2","F3","M1","M2","M3","F1","F2","M1","M2","F1","F2","F3","M1","M2","M3","F1","F2","M1","M2"), col=c("deeppink3","deeppink3","deeppink3","royalblue3","royalblue3","royalblue3","deeppink3","deeppink3","royalblue3","royalblue3","deeppink3","deeppink3","deeppink3","royalblue3","royalblue3","royalblue3","deeppink3","deeppink3","royalblue3","royalblue3"),notch=T, outline = F)
totaldata <- as.numeric(paste(c(SuperTable_normalized$Jap_Som_F1, SuperTable_normalized$Jap_Som_F2, SuperTable_normalized$Jap_Som_F3, SuperTable_normalized$Jap_Som_M1, SuperTable_normalized$Jap_Som_M2, SuperTable_normalized$Jap_Som_M3, SuperTable_normalized$Mans_Som_F1, SuperTable_normalized$Mans_Som_F2, SuperTable_normalized$Mans_Som_M1, SuperTable_normalized$Mans_Som_M2,SuperTable_normalized$Jap_Ad_F1, SuperTable_normalized$Jap_Ad_F2, SuperTable_normalized$Jap_Ad_F3, SuperTable_normalized$Jap_Ad_M1, SuperTable_normalized$Jap_Ad_M2, SuperTable_normalized$Jap_Ad_M3,SuperTable_normalized$Mans_Ad_F1, SuperTable_normalized$Mans_Ad_F2, SuperTable_normalized$Mans_Ad_M1, SuperTable_normalized$Mans_Ad_M2)))
median<- median(totaldata,na.rm=T)
median
abline(h=median, lty=2, lwd=1, col="black")

## CORRELATION ANALYSIS

library(gplots)

# Schistosomula - correlation 
Table_cor_Som <- (subset(SuperTable_normalized, select= c("Jap_Som_F1", "Jap_Som_F2", "Jap_Som_F3", "Jap_Som_M1", "Jap_Som_M2", "Jap_Som_M3", "Mans_Som_F1", "Mans_Som_F2", "Mans_Som_M1", "Mans_Som_M2")))
colors_cor_Som <- c("gray","gray","gray","black","black","black","antiquewhite2","antiquewhite2","antiquewhite4","antiquewhite4")
heatmap.2(cor(Table_cor_Som,method="pearson"),col=colorRampPalette(c("blue","white","red","firebrick4"))(15),ColSideColors = colors_cor_Som,scale="none",symm=T,margins=c(15,15),key=T,trace="none")
legend("topright",legend=c("Male S.mansoni","Female S.mansoni","Female S.japonicum","Male S.japonicum"),col=c("antiquewhite4","antiquewhite2","gray","black"),lty=1,lwd=10)

# Adults - correlation 
Table_cor_Ad <- (subset(SuperTable_normalized, select= c("Jap_Ad_F1", "Jap_Ad_F2", "Jap_Ad_F3", "Jap_Ad_M1", "Jap_Ad_M2", "Jap_Ad_M3","Mans_Ad_F1","Mans_Ad_F2", "Mans_Ad_M1", "Mans_Ad_M2")))
colors_cor_Ad <- c("gray","gray","gray","black","black","black","antiquewhite2","antiquewhite2","antiquewhite4","antiquewhite4")
heatmap.2(cor(Table_cor_Ad,method="pearson"),col=colorRampPalette(c("blue","white","red","firebrick4"))(15),ColSideColors = colors_cor_Ad,scale="none",symm=T,margins=c(15,15),key=T,trace="none")
legend("topright",legend=c("Female S.mansoni","Male S.mansoni","Female S.japonicum","Male S.japonicum"),col=c("antiquewhite2","antiquewhite4","gray","black"),lty=1,lwd=10)


########################
#C. Expression analysis#
########################

# Open SuperTable_normalized
SuperTable_normalized <- read.table("~/InputFile8_SuperTableNormalized_Transcriptomics1_RPKM",fill=TRUE,header=TRUE) ###RPKM normalized table per stage
head(SuperTable_normalized)
nrow(SuperTable_normalized) #7382
#SuperTable_normalized <- read.table("~/InputFile8-2_SuperTableNormalized_LoessOnAll_Transcriptomics1_RPKM",fill=TRUE,header=TRUE) ###RPKM normalized table - all libraries /!\ Table used for PPIs
#nrow(SuperTable_normalized)
#SuperTable_normalized <- read.table("~/InputFile11_SuperTableNormalized_Transcriptomics2_RPKM",fill=TRUE,header=TRUE)  ###RPKM normalized table with WormDB orthologs
#nrow(SuperTable_normalized) #4414
#SuperTable_normalized <- read.table("~/InputFile9_SuperTableNormalized_Transcriptomics1_TPM",fill=TRUE,header=TRUE) ###TPM normalized table
#nrow(SuperTable_normalized) #7382

## CALCULATION AVERAGES AND RATIOS

# Calculate female averages
SuperTable_normalized$Fmean_Som_jap <- as.numeric(paste(SuperTable_normalized$Jap_Som_F1+SuperTable_normalized$Jap_Som_F2+SuperTable_normalized$Jap_Som_F3))/3
SuperTable_normalized$Fmean_Som_mans <- as.numeric(paste(SuperTable_normalized$Mans_Som_F1+SuperTable_normalized$Mans_Som_F2))/2
SuperTable_normalized$Fmean_Ad_jap <- as.numeric(paste(SuperTable_normalized$Jap_Ad_F1+SuperTable_normalized$Jap_Ad_F2+SuperTable_normalized$Jap_Ad_F3))/3
SuperTable_normalized$Fmean_Ad_mans <- as.numeric(paste(SuperTable_normalized$Mans_Ad_F1+SuperTable_normalized$Mans_Ad_F2))/2
# Calculate male averages
SuperTable_normalized$Mmean_Som_jap <- (as.numeric(paste(SuperTable_normalized$Jap_Som_M1+SuperTable_normalized$Jap_Som_M2+SuperTable_normalized$Jap_Som_M3)))/3
SuperTable_normalized$Mmean_Som_mans <- (as.numeric(paste(SuperTable_normalized$Mans_Som_M1+SuperTable_normalized$Mans_Som_M2)))/2
SuperTable_normalized$Mmean_Ad_jap <- (as.numeric(paste(SuperTable_normalized$Jap_Ad_M1+SuperTable_normalized$Jap_Ad_M2+SuperTable_normalized$Jap_Ad_M3)))/3
SuperTable_normalized$Mmean_Ad_mans <- (as.numeric(paste(SuperTable_normalized$Mans_Ad_M1+SuperTable_normalized$Mans_Ad_M2)))/2
# Calculate female:male ratios
SuperTable_normalized$FMratio_Som_jap <- as.numeric(paste(SuperTable_normalized$Jap_Som_F1+SuperTable_normalized$Jap_Som_F2+SuperTable_normalized$Jap_Som_F3))/(as.numeric(paste(SuperTable_normalized$Jap_Som_M1+SuperTable_normalized$Jap_Som_M2+SuperTable_normalized$Jap_Som_M3)))
SuperTable_normalized$FMratio_Som_mans <- as.numeric(paste(SuperTable_normalized$Mans_Som_F1+SuperTable_normalized$Mans_Som_F2))/(as.numeric(paste(SuperTable_normalized$Mans_Som_M1+SuperTable_normalized$Mans_Som_M2)))
SuperTable_normalized$FMratio_Ad_jap <- as.numeric(paste(SuperTable_normalized$Jap_Ad_F1+SuperTable_normalized$Jap_Ad_F2+SuperTable_normalized$Jap_Ad_F3))/(as.numeric(paste(SuperTable_normalized$Jap_Ad_M1+SuperTable_normalized$Jap_Ad_M2+SuperTable_normalized$Jap_Ad_M3)))
SuperTable_normalized$FMratio_Ad_mans <- as.numeric(paste(SuperTable_normalized$Mans_Ad_F1+SuperTable_normalized$Mans_Ad_F2))/(as.numeric(paste(SuperTable_normalized$Mans_Ad_M1+SuperTable_normalized$Mans_Ad_M2)))
# Calculate log2(F:M ratio)
SuperTable_normalized$FMlog_Som_jap <- log2(as.numeric(paste(SuperTable_normalized$FMratio_Som_jap)))
SuperTable_normalized$FMlog_Som_mans <- log2(as.numeric(paste(SuperTable_normalized$FMratio_Som_mans)))
SuperTable_normalized$FMlog_Ad_jap <- log2(as.numeric(paste(SuperTable_normalized$FMratio_Ad_jap)))
SuperTable_normalized$FMlog_Ad_mans <- log2(as.numeric(paste(SuperTable_normalized$FMratio_Ad_mans)))
# Calculate interaction with the Z
SuperTable_normalized$Zinter_exp <- (SuperTable_normalized$Zcount_exp/(SuperTable_normalized$Zcount_exp+SuperTable_normalized$Autocount_exp))
SuperTable_normalized$Zinter_all <- (SuperTable_normalized$Zcount_all/(SuperTable_normalized$Zcount_all+SuperTable_normalized$Autocount_all))

## FILTERING
  
#Define expression filter
explim <- 1 #Here put the min expression (initial rpkm min=0.000001)
explim_max <- 5 #Here put the max expression 

#Minimum expression treshold - Filter per stage
ST_norm_Som <- subset(SuperTable_normalized, Fmean_Som_jap>explim & Fmean_Som_mans>explim & Mmean_Som_jap>explim & Mmean_Som_mans>explim)
nrow(ST_norm_Som) #4919 for RPKM1
ST_norm_Ad <- subset(SuperTable_normalized, Fmean_Ad_jap>explim & Fmean_Ad_mans>explim & Mmean_Ad_jap>explim & Mmean_Ad_mans>explim)
nrow(ST_norm_Ad) #4281 for RPKM1

#Maximum expression treshold - Filter per stage
ST_norm_Som <- subset(ST_norm_Som, Fmean_Som_jap<explim_max & Fmean_Som_mans<explim_max & Mmean_Som_jap<explim_max & Mmean_Som_mans<explim_max)
nrow(ST_norm_Som) # 1928 for RPKM10 (and min RPKM>1)
ST_norm_Ad <- subset(ST_norm_Ad, Fmean_Ad_jap<explim_max & Fmean_Ad_mans<explim_max & Mmean_Ad_jap<explim_max & Mmean_Ad_mans<explim_max)
nrow(ST_norm_Ad) # 1492 for RPKM10 (and min RPKM>1)

# Filter for both stages (it will generate twice the same table)
#ST_norm_Som <- subset(SuperTable_normalized, Fmean_Som_jap>explim & Fmean_Som_mans>explim & Mmean_Som_jap>explim & Mmean_Som_mans>explim & Fmean_Ad_jap>explim & Fmean_Ad_mans>explim & Mmean_Ad_jap>explim & Mmean_Ad_mans>explim)
#nrow(ST_norm_Som) #4242 for RPKM1
#ST_norm_Ad <- subset(SuperTable_normalized, Fmean_Som_jap>explim & Fmean_Som_mans>explim & Mmean_Som_jap>explim & Mmean_Som_mans>explim & Fmean_Ad_jap>explim & Fmean_Ad_mans>explim & Mmean_Ad_jap>explim & Mmean_Ad_mans>explim)
#nrow(ST_norm_Ad) #4242 for RPKM1

# Exclude sex bias - without considering the ancestry 
#ST_norm_Som <- subset(ST_norm_Som, FMratio_Som_jap<2 & FMratio_Som_jap>0.5 & FMratio_Som_mans<2 & FMratio_Som_mans>0.5)
#nrow(ST_norm_Som) #4495 for RPKM1
#ST_norm_Ad <- subset(ST_norm_Ad, FMratio_Ad_jap<2 & FMratio_Ad_jap>0.5 & FMratio_Ad_mans<2 & FMratio_Ad_mans>0.5)
#nrow(ST_norm_Ad) #2862 for RPKM1

##SUBSET TABLES

#Schistosomula - Subset by STRINGENT strata (Method1)
levels(ST_norm_Som$Strata1_Stringent)
ST_norm_Som_S0 <- subset(ST_norm_Som, Strata1_Stringent=="S0")
nrow(ST_norm_Som_S0) #219 for RPKM1
ST_norm_Som_S1_jap <- subset(ST_norm_Som, Strata1_Stringent=="S1_jap")
nrow(ST_norm_Som_S1_jap) #32 for RPKM1
ST_norm_Som_Z_jap <- subset(ST_norm_Som, Strata1_Stringent=="S0" | Strata1_Stringent=="S1_jap")
nrow(ST_norm_Som_Z_jap) #251 for RPKM1
ST_norm_Som_S1_mans  <- subset(ST_norm_Som, Strata1_Stringent=="S1_mans")
nrow(ST_norm_Som_S1_mans) #92 for RPKM1
ST_norm_Som_Z_mans <- subset(ST_norm_Som, Strata1_Stringent=="S0" | Strata1_Stringent=="S1_mans")
nrow(ST_norm_Som_Z_mans) #311 for RPKM1
ST_norm_Som_Aut <- subset(ST_norm_Som, Strata1_Stringent=="Aut_Shared")
nrow(ST_norm_Som_Aut) #2472 for RPKM1
ST_norm_Som_PSA <- subset(ST_norm_Som, Strata1_Stringent=="PSA_shared")
nrow(ST_norm_Som_PSA) #369 for RPKM1

#Adults - Subset by STRINGENT strata (Method1)
levels(ST_norm_Ad$Strata1_Stringent)
ST_norm_Ad_S0 <- subset(ST_norm_Ad, Strata1_Stringent=="S0")
nrow(ST_norm_Ad_S0) #203 for RPKM1
ST_norm_Ad_S1_jap <- subset(ST_norm_Ad, Strata1_Stringent=="S1_jap")
nrow(ST_norm_Ad_S1_jap) #28 for RPKM1
ST_norm_Ad_Z_jap <- subset(ST_norm_Ad, Strata1_Stringent=="S0" | Strata1_Stringent=="S1_jap")
nrow(ST_norm_Ad_Z_jap) #231 for RPKM1
ST_norm_Ad_S1_mans  <- subset(ST_norm_Ad, Strata1_Stringent=="S1_mans")
nrow(ST_norm_Ad_S1_mans) #79 for RPKM1
ST_norm_Ad_Z_mans <- subset(ST_norm_Ad, Strata1_Stringent=="S0" | Strata1_Stringent=="S1_mans")
nrow(ST_norm_Ad_Z_mans) #282 for RPKM1
ST_norm_Ad_Aut <- subset(ST_norm_Ad, Strata1_Stringent=="Aut_Shared")
nrow(ST_norm_Ad_Aut) #2137 for RPKM1
ST_norm_Ad_PSA <- subset(ST_norm_Ad, Strata1_Stringent=="PSA_shared")
nrow(ST_norm_Ad_PSA) #315 for RPKM1

#Schistosomula - Subset by EXHAUSTIVE strata (Method2)
levels(ST_norm_Som$Strata2_Exhaustive)
ST_norm_Som_S0 <- subset(ST_norm_Som, Strata2_Exhaustive=="S0")
nrow(ST_norm_Som_S0) #287 for RPKM1
ST_norm_Som_S1_jap <- subset(ST_norm_Som, Strata2_Exhaustive=="S1_jap")
nrow(ST_norm_Som_S1_jap) #67 for RPKM1
ST_norm_Som_Z_jap <- subset(ST_norm_Som, Strata2_Exhaustive=="S0" | Strata2_Exhaustive=="S1_jap")
nrow(ST_norm_Som_Z_jap) #354 for RPKM1
ST_norm_Som_S1_mans  <- subset(ST_norm_Som, Strata2_Exhaustive=="S1_mans")
nrow(ST_norm_Som_S1_mans) #142 for RPKM1
ST_norm_Som_Z_mans <- subset(ST_norm_Som, Strata2_Exhaustive=="S0" | Strata2_Exhaustive=="S1_mans")
nrow(ST_norm_Som_Z_mans) #429 for RPKM1
ST_norm_Som_Aut <- subset(ST_norm_Som, Strata2_Exhaustive=="Aut_Shared")
nrow(ST_norm_Som_Aut) #2472 for RPKM1
ST_norm_Som_PSA <- subset(ST_norm_Som, Strata2_Exhaustive=="PSA_shared")
nrow(ST_norm_Som_PSA) #369 for RPKM1

#Adults - Subset by EXHAUSTIVE strata (Method2)
levels(ST_norm_Ad$Strata2_Exhaustive)
ST_norm_Ad_S0 <- subset(ST_norm_Ad, Strata2_Exhaustive=="S0")
nrow(ST_norm_Ad_S0) #266 for RPKM1
ST_norm_Ad_S1_jap <- subset(ST_norm_Ad, Strata2_Exhaustive=="S1_jap")
nrow(ST_norm_Ad_S1_jap) #58 for RPKM1
ST_norm_Ad_Z_jap <- subset(ST_norm_Ad, Strata2_Exhaustive=="S0" | Strata2_Exhaustive=="S1_jap")
nrow(ST_norm_Ad_Z_jap) #324 for RPKM1
ST_norm_Ad_S1_mans  <- subset(ST_norm_Ad, Strata2_Exhaustive=="S1_mans")
nrow(ST_norm_Ad_S1_mans) #124 for RPKM1
ST_norm_Ad_Z_mans <- subset(ST_norm_Ad, Strata2_Exhaustive=="S0" | Strata2_Exhaustive=="S1_mans")
nrow(ST_norm_Ad_Z_mans) #390 for RPKM1
ST_norm_Ad_Aut <- subset(ST_norm_Ad, Strata2_Exhaustive=="Aut_Shared")
nrow(ST_norm_Ad_Aut) #2137 for RPKM1
ST_norm_Ad_PSA <- subset(ST_norm_Ad, Strata2_Exhaustive=="PSA_shared")
nrow(ST_norm_Ad_PSA) #315 for RPKM1

# Exclude sex bias considering ancestry
#ST_norm_Som_S1_jap <- subset(ST_norm_Som_S1_jap, (Fmean_Som_jap/Fmean_Som_mans)/(Mmean_Som_jap/Mmean_Som_mans)<2 & (Fmean_Som_jap/Fmean_Som_mans)/(Mmean_Som_jap/Mmean_Som_mans)>0.5)
#ST_norm_Som_S1_mans <- subset(ST_norm_Som_S1_mans, (Fmean_Som_mans/Fmean_Som_jap)/(Mmean_Som_mans/Mmean_Som_jap)<2 & (Fmean_Som_mans/Fmean_Som_jap)/(Mmean_Som_mans/Mmean_Som_jap)>0.5)
#ST_norm_Ad_S1_jap <- subset(ST_norm_Ad_S1_jap, (Fmean_Ad_jap/Fmean_Ad_mans)/(Mmean_Ad_jap/Mmean_Ad_mans)<2 & (Fmean_Ad_jap/Fmean_Ad_mans)/(Mmean_Ad_jap/Mmean_Ad_mans)>0.5)
#ST_norm_Ad_S1_mans <- subset(ST_norm_Ad_S1_mans, (Fmean_Ad_mans/Fmean_Ad_jap)/(Mmean_Ad_mans/Mmean_Ad_jap)<2 & (Fmean_Ad_mans/Fmean_Ad_jap)/(Mmean_Ad_mans/Mmean_Ad_jap)>0.5)
#ST_norm_Som_Aut <- subset(ST_norm_Som_Aut, (Fmean_Som_jap/Fmean_Som_mans)/(Mmean_Som_jap/Mmean_Som_mans)<2 & (Fmean_Som_jap/Fmean_Som_mans)/(Mmean_Som_jap/Mmean_Som_mans)>0.5)
#ST_norm_Som_Aut <- subset(ST_norm_Som_Aut, (Fmean_Som_mans/Fmean_Som_jap)/(Mmean_Som_mans/Mmean_Som_jap)<2 & (Fmean_Som_mans/Fmean_Som_jap)/(Mmean_Som_mans/Mmean_Som_jap)>0.5)
#ST_norm_Ad_Aut <- subset(ST_norm_Ad_Aut, (Fmean_Ad_jap/Fmean_Ad_mans)/(Mmean_Ad_jap/Mmean_Ad_mans)<2 & (Fmean_Ad_jap/Fmean_Ad_mans)/(Mmean_Ad_jap/Mmean_Ad_mans)>0.5)
#ST_norm_Ad_Aut <- subset(ST_norm_Ad_Aut, (Fmean_Ad_mans/Fmean_Ad_jap)/(Mmean_Ad_mans/Mmean_Ad_jap)<2 & (Fmean_Ad_mans/Fmean_Ad_jap)/(Mmean_Ad_mans/Mmean_Ad_jap)>0.5)

###########################
#FIGURE 2 : Z vs AUTOSOMES#
###########################

## PLOTS 
layout(matrix(c(1,1,2,3,3,4,5,5,6,7,7,8), 2, 6, byrow = TRUE))
par(mar=c(3,5,3,1))
#Japonicum schistosomula - without ancestry  
boxplot(log2(ST_norm_Som_Z_jap$Fmean_Som_jap), log2(ST_norm_Som_Aut$Fmean_Som_jap), log2(ST_norm_Som_Z_jap$Mmean_Som_jap), log2(ST_norm_Som_Aut$Mmean_Som_jap), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="log2(RPKM)", ylim=c(0,10.5),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="A. Sj SCHISTOSOMULA - Per sex")
boxplot(ST_norm_Som_Z_jap$FMlog_Som_jap,ST_norm_Som_Aut$FMlog_Som_jap, names = c("Z","A"), ylab="log2(F:M)",ylim=c(-2.5,2.5),cex.axis=1.5, cex.lab=2,notch=T, outline = F, col=c("sienna1","grey"), main="B. Sj SCHISTOSOMULA - F:M")
#Japonicum adults - without ancestry  
boxplot(log2(ST_norm_Ad_Z_jap$Fmean_Ad_jap), log2(ST_norm_Ad_Aut$Fmean_Ad_jap), log2(ST_norm_Ad_Z_jap$Mmean_Ad_jap), log2(ST_norm_Ad_Aut$Mmean_Ad_jap), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="log2(RPKM)", ylim=c(0,10.5),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="C. Sj ADULTS - Per sex")
boxplot(ST_norm_Ad_Z_jap$FMlog_Ad_jap,ST_norm_Ad_Aut$FMlog_Ad_jap, names = c("Z","A"), ylab="log2(F:M)",ylim=c(-2.5,2.5),cex.axis=1.5, cex.lab=2,notch=T, outline = F, col=c("sienna1","grey"), main="D. Sj ADULTS - F:M")
#Mansoni schistosomula - without ancestry
boxplot(log2(ST_norm_Som_Z_mans$Fmean_Som_mans), log2(ST_norm_Som_Aut$Fmean_Som_mans),log2(ST_norm_Som_Z_mans$Mmean_Som_mans),log2(ST_norm_Som_Aut$Mmean_Som_mans), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="log2(RPKM)",ylim=c(0,10.5),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="E. Sm SCHISTOSOMULA - Per sex")
boxplot(ST_norm_Som_Z_mans$FMlog_Som_mans,ST_norm_Som_Aut$FMlog_Som_mans, names = c("Z","A"), ylab="log2(F:M)",ylim=c(-2.5,2.5),cex.axis=1.5, cex.lab=2,notch=T, outline = F, col=c("sienna1","grey"), main="F. Sm SCHISTOSOMULA - F:M")
#Mansoni adults - without ancestry
boxplot(log2(ST_norm_Ad_Z_mans$Fmean_Ad_mans), log2(ST_norm_Ad_Aut$Fmean_Ad_mans),log2(ST_norm_Ad_Z_mans$Mmean_Ad_mans), log2(ST_norm_Ad_Aut$Mmean_Ad_mans), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="log2(RPKM)", ylim=c(0,10.5),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="G. Sm ADULTS - Per sex")
boxplot(ST_norm_Ad_Z_mans$FMlog_Ad_mans,ST_norm_Ad_Aut$FMlog_Ad_mans, names = c("Z","A"), ylab="log2(F:M)",ylim=c(-2.5,2.5),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("sienna1","grey"), main="H. Sm ADULTS - F:M")

#All conditions F:M ratio (Supplementary Figures)
layout(matrix(c(1,2,3,4,5,6,7,8), 1, 4, byrow = TRUE))
par(mar=c(3,5,5,1))
boxplot(log2(ST_norm_Som_Z_jap$Fmean_Som_jap), log2(ST_norm_Som_Aut$Fmean_Som_jap), log2(ST_norm_Som_Z_jap$Mmean_Som_jap), log2(ST_norm_Som_Aut$Mmean_Som_jap), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="log2(RPKM)", ylim=c(0,10),cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="A. Sj SCHISTOSOMULA - Per sex")
boxplot(log2(ST_norm_Ad_Z_jap$Fmean_Ad_jap), log2(ST_norm_Ad_Aut$Fmean_Ad_jap), log2(ST_norm_Ad_Z_jap$Mmean_Ad_jap), log2(ST_norm_Ad_Aut$Mmean_Ad_jap), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="log2(RPKM)", ylim=c(0,10),cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="C. Sj ADULTS - Per sex")
boxplot(log2(ST_norm_Som_Z_mans$Fmean_Som_mans), log2(ST_norm_Som_Aut$Fmean_Som_mans),log2(ST_norm_Som_Z_mans$Mmean_Som_mans),log2(ST_norm_Som_Aut$Mmean_Som_mans), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="log2(RPKM)",ylim=c(0,10),cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="E. Sm SCHISTOSOMULA - Per sex")
boxplot(log2(ST_norm_Ad_Z_mans$Fmean_Ad_mans), log2(ST_norm_Ad_Aut$Fmean_Ad_mans),log2(ST_norm_Ad_Z_mans$Mmean_Ad_mans), log2(ST_norm_Ad_Aut$Mmean_Ad_mans), names = c("Fem-Z","Fem-A","Male-Z","Male-A"), ylab="log2(RPKM)", ylim=c(0,10),cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="G. Sm ADULTS - Per sex")
#mtext("RPKM>3 threshold on all libraries", outer=TRUE,  cex=1, line=-1.5, col="grey")
mtext("RPKM>1 per stage & FC<2", outer=TRUE,  cex=1, line=-1.5, col="grey")

#All conditions female and male gene expression (Supplementary Figures)
layout(matrix(c(1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8), 1, 8, byrow = TRUE))
par(mar=c(3,5,5,1))
boxplot(ST_norm_Som_Z_jap$FMlog_Som_jap,ST_norm_Som_Aut$FMlog_Som_jap, names = c("Z","A"), ylab="log2(F:M)",ylim=c(-1,1),cex.axis=1, cex.lab=1.5,notch=T, outline = F, col=c("sienna1","grey"), main="B. Sj SCHISTOSOMULA - F:M")
boxplot(ST_norm_Ad_Z_jap$FMlog_Ad_jap,ST_norm_Ad_Aut$FMlog_Ad_jap, names = c("Z","A"), ylab="log2(F:M)",ylim=c(-1,1),cex.axis=1, cex.lab=1.5,notch=T, outline = F, col=c("sienna1","grey"), main="D. Sj ADULTS - F:M")
boxplot(ST_norm_Som_Z_mans$FMlog_Som_mans,ST_norm_Som_Aut$FMlog_Som_mans, names = c("Z","A"), ylab="log2(F:M)",ylim=c(-1,1),cex.axis=1, cex.lab=1.5,notch=T, outline = F, col=c("sienna1","grey"), main="F. Sm SCHISTOSOMULA - F:M")
boxplot(ST_norm_Ad_Z_mans$FMlog_Ad_mans,ST_norm_Ad_Aut$FMlog_Ad_mans, names = c("Z","A"), ylab="log2(F:M)",ylim=c(-1,1),cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey"), main="H. Sm ADULTS - F:M")
#mtext("RPKM>3 threshold on all libraries", outer=TRUE,  cex=1, line=-1.5, col="grey")
mtext("RPKM>1 per stage & FC<2", outer=TRUE,  cex=1, line=-1.5, col="grey")

## STATISTICS

#Japonicum: schistosomula
wilcox.test(ST_norm_Som_Z_jap$Fmean_Som_jap,ST_norm_Som_Aut$Fmean_Som_jap)$p.value
median(ST_norm_Som_Z_jap$Fmean_Som_jap) / median(ST_norm_Som_Aut$Fmean_Som_jap)
wilcox.test(ST_norm_Som_Z_jap$Mmean_Som_jap,ST_norm_Som_Aut$Mmean_Som_jap)$p.value
median(ST_norm_Som_Z_jap$Mmean_Som_jap) / median(ST_norm_Som_Aut$Mmean_Som_jap)
wilcox.test(ST_norm_Som_Z_jap$FMratio_Som_jap,ST_norm_Som_Aut$FMratio_Som_jap)$p.value
median(ST_norm_Som_Z_jap$FMratio_Som_jap) / median(ST_norm_Som_Aut$FMratio_Som_jap)

wilcox.test(ST_norm_Som_Z_jap$Fmean_Som_jap,ST_norm_Som_Z_jap$Mmean_Som_jap)$p.value
median(ST_norm_Som_Z_jap$FMratio_Som_jap)
wilcox.test(ST_norm_Som_Aut$Fmean_Som_jap,ST_norm_Som_Aut$Mmean_Som_jap)$p.value
median(ST_norm_Som_Aut$FMratio_Som_jap)

#Japonicum: adults
wilcox.test(ST_norm_Ad_Z_jap$Fmean_Ad_jap,ST_norm_Ad_Aut$Fmean_Ad_jap)$p.value
median(ST_norm_Ad_Z_jap$Fmean_Ad_jap) / median(ST_norm_Ad_Aut$Fmean_Ad_jap)
wilcox.test(ST_norm_Ad_Z_jap$Mmean_Ad_jap,ST_norm_Ad_Aut$Mmean_Ad_jap)$p.value
median(ST_norm_Ad_Z_jap$Mmean_Ad_jap) / median(ST_norm_Ad_Aut$Mmean_Ad_jap)
wilcox.test(ST_norm_Ad_Z_jap$FMratio_Ad_jap,ST_norm_Ad_Aut$FMratio_Ad_jap)$p.value
median(ST_norm_Ad_Z_jap$FMratio_Ad_jap) / median(ST_norm_Ad_Aut$FMratio_Ad_jap)

wilcox.test(ST_norm_Ad_Z_jap$Fmean_Ad_jap,ST_norm_Ad_Z_jap$Mmean_Ad_jap)$p.value
median(ST_norm_Ad_Z_jap$FMratio_Ad_jap) 
wilcox.test(ST_norm_Ad_Aut$Fmean_Ad_jap,ST_norm_Ad_Aut$Mmean_Ad_jap)$p.value
median(ST_norm_Ad_Aut$FMratio_Ad_jap)

#Mansoni: schistosomula
wilcox.test(ST_norm_Som_Z_mans$Fmean_Som_mans,ST_norm_Som_Aut$Fmean_Som_mans)$p.value
median(ST_norm_Som_Z_mans$Fmean_Som_mans) / median(ST_norm_Som_Aut$Fmean_Som_mans)
wilcox.test(ST_norm_Som_Z_mans$Mmean_Som_mans,ST_norm_Som_Aut$Mmean_Som_mans)$p.value
median(ST_norm_Som_Z_mans$Mmean_Som_mans) / median(ST_norm_Som_Aut$Mmean_Som_mans)
wilcox.test(ST_norm_Som_Z_mans$FMratio_Som_mans,ST_norm_Som_Aut$FMratio_Som_mans)$p.value
median(ST_norm_Som_Z_mans$FMratio_Som_mans) / median(ST_norm_Som_Aut$FMratio_Som_mans)

wilcox.test(ST_norm_Som_Z_mans$Fmean_Som_mans,ST_norm_Som_Z_mans$Mmean_Som_mans)$p.value
median(ST_norm_Som_Z_mans$FMratio_Som_mans) 
wilcox.test(ST_norm_Som_Aut$Fmean_Som_mans,ST_norm_Som_Aut$Mmean_Som_mans)$p.value
median(ST_norm_Som_Aut$FMratio_Som_mans)

#Mansoni: adults
wilcox.test(ST_norm_Ad_Z_mans$Fmean_Ad_mans,ST_norm_Ad_Aut$Fmean_Ad_mans)$p.value
median(ST_norm_Ad_Z_mans$Fmean_Ad_mans) / median(ST_norm_Ad_Aut$Fmean_Ad_mans)
wilcox.test(ST_norm_Ad_Z_mans$Mmean_Ad_mans,ST_norm_Ad_Aut$Mmean_Ad_mans)$p.value
median(ST_norm_Ad_Z_mans$Mmean_Ad_mans) / median(ST_norm_Ad_Aut$Mmean_Ad_mans)
wilcox.test(ST_norm_Ad_Z_mans$FMratio_Ad_mans,ST_norm_Ad_Aut$FMratio_Ad_mans)$p.value
median(ST_norm_Ad_Z_mans$FMratio_Ad_mans) / median(ST_norm_Ad_Aut$FMratio_Ad_mans)

wilcox.test(ST_norm_Ad_Z_mans$Fmean_Ad_mans,ST_norm_Ad_Z_mans$Mmean_Ad_mans)$p.value
median(ST_norm_Ad_Z_mans$FMratio_Ad_mans) 
wilcox.test(ST_norm_Ad_Aut$Fmean_Ad_mans,ST_norm_Ad_Aut$Mmean_Ad_mans)$p.value
median(ST_norm_Ad_Aut$FMratio_Ad_mans)

##############################
#FIGURE3: STRATA and ANCESTRY#
##############################

##PLOTS
layout(matrix(c(1,1,2,3,3,4,5,5,6,7,7,8), 2, 6, byrow = TRUE))
par(mar=c(3,5,3,1))
#Japonicum schistosomula - with ancestry  = RATIO Jap/Mans
boxplot(log2(ST_norm_Som_S1_jap$Fmean_Som_jap/ST_norm_Som_S1_jap$Fmean_Som_mans),log2(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans),log2(ST_norm_Som_S1_jap$Mmean_Som_jap/ST_norm_Som_S1_jap$Mmean_Som_mans), log2(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans), names = c("Fem-S1j","Fem-A","Male-S1j","Male-A"), ylab="log2(S.jap/S.mans)",ylim=c(-4,4),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="A. Sj SCHISTOSOMULA")
boxplot(log2((ST_norm_Som_S1_jap$Fmean_Som_jap/ST_norm_Som_S1_jap$Fmean_Som_mans)/(ST_norm_Som_S1_jap$Mmean_Som_jap/ST_norm_Som_S1_jap$Mmean_Som_mans)),log2((ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans)/(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans)), names = c("S1j","A"), ylab="log2(F:M)",ylim=c(-2.5,2),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("sienna1","grey"), main="B. Sj SCHISTOSOMULA - F:M")
#Japonicum adults - with ancestry = RATIO Jap/Mans
boxplot(log2(ST_norm_Ad_S1_jap$Fmean_Ad_jap/ST_norm_Ad_S1_jap$Fmean_Ad_mans), log2(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans),log2(ST_norm_Ad_S1_jap$Mmean_Ad_jap/ST_norm_Ad_S1_jap$Mmean_Ad_mans), log2(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans), names = c("Fem-S1j","Fem-A","Male-S1j","Male-A"), ylab="log2(S.jap/S.mans)", ylim=c(-4,4),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="C. Sj ADULTS")
boxplot(log2((ST_norm_Ad_S1_jap$Fmean_Ad_jap/ST_norm_Ad_S1_jap$Fmean_Ad_mans)/(ST_norm_Ad_S1_jap$Mmean_Ad_jap/ST_norm_Ad_S1_jap$Mmean_Ad_mans)),log2((ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans)/(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans)), names = c("S1j","A"), ylab="log2(F:M)",ylim=c(-2.5,2),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("sienna1","grey"), main="D. Sj ADULTS - F:M")
#Mansoni schistosomula - with ancestry = RATIO Mans/Jap
boxplot(log2(ST_norm_Som_S1_mans$Fmean_Som_mans/ST_norm_Som_S1_mans$Fmean_Som_jap), log2(ST_norm_Som_Aut$Fmean_Som_mans/ST_norm_Som_Aut$Fmean_Som_jap),log2(ST_norm_Som_S1_mans$Mmean_Som_mans/ST_norm_Som_S1_mans$Mmean_Som_jap), log2(ST_norm_Som_Aut$Mmean_Som_mans/ST_norm_Som_Aut$Mmean_Som_jap), names = c("Fem-S1m","Fem-A","Male-S1m","Male-A"), ylab="log2(S.mans/S.jap)",ylim=c(-4,4),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="E. Sm SCHISTOSOMULA")
boxplot(log2((ST_norm_Som_S1_mans$Fmean_Som_mans/ST_norm_Som_S1_mans$Fmean_Som_jap)/(ST_norm_Som_S1_mans$Mmean_Som_mans/ST_norm_Som_S1_mans$Mmean_Som_jap)),log2((ST_norm_Som_Aut$Fmean_Som_mans/ST_norm_Som_Aut$Fmean_Som_jap)/(ST_norm_Som_Aut$Mmean_Som_mans/ST_norm_Som_Aut$Mmean_Som_jap)), names = c("S1m","A"), ylab="log2(F:M)",ylim=c(-2.5,2),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("sienna1","grey"), main="F. Sm SCHISTOSOMULA - F:M")
#Mansoni adults - with ancestry = RATIO Mans/Jap
boxplot(log2(ST_norm_Ad_S1_mans$Fmean_Ad_mans/ST_norm_Ad_S1_mans$Fmean_Ad_jap), log2(ST_norm_Ad_Aut$Fmean_Ad_mans/ST_norm_Ad_Aut$Fmean_Ad_jap),log2(ST_norm_Ad_S1_mans$Mmean_Ad_mans/ST_norm_Ad_S1_mans$Mmean_Ad_jap), log2(ST_norm_Ad_Aut$Mmean_Ad_mans/ST_norm_Ad_Aut$Mmean_Ad_jap),  names = c("Fem-S1m","Fem-A","Male-S1m","Male-A"), ylab="log2(S.mans/S.jap)",ylim=c(-4,4),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="G. Sm ADULTS")
boxplot(log2((ST_norm_Ad_S1_mans$Fmean_Ad_mans/ST_norm_Ad_S1_mans$Fmean_Ad_jap)/(ST_norm_Ad_S1_mans$Mmean_Ad_mans/ST_norm_Ad_S1_mans$Mmean_Ad_jap)),log2((ST_norm_Ad_Aut$Fmean_Ad_mans/ST_norm_Ad_Aut$Fmean_Ad_jap)/(ST_norm_Ad_Aut$Mmean_Ad_mans/ST_norm_Ad_Aut$Mmean_Ad_jap)), names = c("S1m","A"), ylab="log2(F:M)",ylim=c(-2.5,2),cex.axis=1.5, cex.lab=2, notch=T, outline = F, col=c("sienna1","grey"), main="H. Sm ADULTS - F:M")

#All conditions F:M ratio (Supplementary Figures)
layout(matrix(c(1,2,3,4,5,6,7,8), 1, 4, byrow = TRUE))
par(mar=c(3,5,5,1))
boxplot(log2((ST_norm_Som_S1_jap$Fmean_Som_jap/ST_norm_Som_S1_jap$Fmean_Som_mans)/(ST_norm_Som_S1_jap$Mmean_Som_jap/ST_norm_Som_S1_jap$Mmean_Som_mans)),log2((ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans)/(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans)), names = c("S1jap","A"), ylab="log2(F:M)",ylim=c(-1,1),cex.axis=1.5, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey"), main="I. S.jap SCHISTOSOMULA")
boxplot(log2((ST_norm_Ad_S1_jap$Fmean_Ad_jap/ST_norm_Ad_S1_jap$Fmean_Ad_mans)/(ST_norm_Ad_S1_jap$Mmean_Ad_jap/ST_norm_Ad_S1_jap$Mmean_Ad_mans)),log2((ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans)/(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans)), names = c("S1jap","A"), ylab="log2(F:M)",ylim=c(-1,1),cex.axis=1.5, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey"), main="J. S.jap ADULTS")
boxplot(log2((ST_norm_Som_S1_mans$Fmean_Som_mans/ST_norm_Som_S1_mans$Fmean_Som_jap)/(ST_norm_Som_S1_mans$Mmean_Som_mans/ST_norm_Som_S1_mans$Mmean_Som_jap)),log2((ST_norm_Som_Aut$Fmean_Som_mans/ST_norm_Som_Aut$Fmean_Som_jap)/(ST_norm_Som_Aut$Mmean_Som_mans/ST_norm_Som_Aut$Mmean_Som_jap)), names = c("S1mans","A"), ylab="log2(F:M)",ylim=c(-1,1),cex.axis=1.5, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey"), main="K. S.mans SCHISTOSOMULA")
boxplot(log2((ST_norm_Ad_S1_mans$Fmean_Ad_mans/ST_norm_Ad_S1_mans$Fmean_Ad_jap)/(ST_norm_Ad_S1_mans$Mmean_Ad_mans/ST_norm_Ad_S1_mans$Mmean_Ad_jap)),log2((ST_norm_Ad_Aut$Fmean_Ad_mans/ST_norm_Ad_Aut$Fmean_Ad_jap)/(ST_norm_Ad_Aut$Mmean_Ad_mans/ST_norm_Ad_Aut$Mmean_Ad_jap)), names = c("S1mans","A"), ylab="log2(F:M)",ylim=c(-1,1),cex.axis=1.5, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey"), main="L. S.mans ADULTS")
mtext("RPKM>1 per stage & FC<2", outer=TRUE,  cex=1, line=-1.5, col="grey")

#All conditions female and male gene expression (Supplementary Figures)
layout(matrix(c(1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8), 1, 8, byrow = TRUE))
par(mar=c(3,5,5,1))
boxplot(log2(ST_norm_Som_S1_jap$Fmean_Som_jap/ST_norm_Som_S1_jap$Fmean_Som_mans),log2(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans),log2(ST_norm_Som_S1_jap$Mmean_Som_jap/ST_norm_Som_S1_jap$Mmean_Som_mans), log2(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans), names = c("Fem-S1j","Fem-A","Male-S1j","Male-A"), ylab="log2(S.jap/S.mans)",ylim=c(-4,4.5),cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="I. Sj SCHISTOSOMULA")
boxplot(log2(ST_norm_Ad_S1_jap$Fmean_Ad_jap/ST_norm_Ad_S1_jap$Fmean_Ad_mans), log2(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans),log2(ST_norm_Ad_S1_jap$Mmean_Ad_jap/ST_norm_Ad_S1_jap$Mmean_Ad_mans), log2(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans), names = c("Fem-S1j","Fem-A","Male-S1j","Male-A"), ylab="log2(S.jap/S.mans)", ylim=c(-4,4.5),cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="J. Sj ADULTS")
boxplot(log2(ST_norm_Som_S1_mans$Fmean_Som_mans/ST_norm_Som_S1_mans$Fmean_Som_jap), log2(ST_norm_Som_Aut$Fmean_Som_mans/ST_norm_Som_Aut$Fmean_Som_jap),log2(ST_norm_Som_S1_mans$Mmean_Som_mans/ST_norm_Som_S1_mans$Mmean_Som_jap), log2(ST_norm_Som_Aut$Mmean_Som_mans/ST_norm_Som_Aut$Mmean_Som_jap), names = c("Fem-S1m","Fem-A","Male-S1m","Male-A"), ylab="log2(S.mans/S.jap)",ylim=c(-4,4.5),cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="K. Sm SCHISTOSOMULA")
boxplot(log2(ST_norm_Ad_S1_mans$Fmean_Ad_mans/ST_norm_Ad_S1_mans$Fmean_Ad_jap), log2(ST_norm_Ad_Aut$Fmean_Ad_mans/ST_norm_Ad_Aut$Fmean_Ad_jap),log2(ST_norm_Ad_S1_mans$Mmean_Ad_mans/ST_norm_Ad_S1_mans$Mmean_Ad_jap), log2(ST_norm_Ad_Aut$Mmean_Ad_mans/ST_norm_Ad_Aut$Mmean_Ad_jap),  names = c("Fem-S1m","Fem-A","Male-S1m","Male-A"), ylab="log2(S.mans/S.jap)",ylim=c(-4,4.5),cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("deeppink2","deeppink4","royalblue2","royalblue4"), main="L. Sm ADULTS")
#mtext("RPKM>3 threshold on all libraries", outer=TRUE,  cex=1, line=-1.5, col="grey")
mtext("RPKM>1 per stage & FC<2", outer=TRUE,  cex=1, line=-1.5, col="grey")

## STATISTICS

# Japonicum: schistosomula
median(ST_norm_Som_S1_jap$Fmean_Som_jap/ST_norm_Som_S1_jap$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans)
wilcox.test((ST_norm_Som_S1_jap$Fmean_Som_jap/ST_norm_Som_S1_jap$Fmean_Som_mans),(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans))$p.value
median(ST_norm_Som_S1_jap$Mmean_Som_jap/ST_norm_Som_S1_jap$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans)
wilcox.test((ST_norm_Som_S1_jap$Mmean_Som_jap/ST_norm_Som_S1_jap$Mmean_Som_mans),(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans))$p.value
(median(ST_norm_Som_S1_jap$Fmean_Som_jap/ST_norm_Som_S1_jap$Fmean_Som_mans)/median(ST_norm_Som_S1_jap$Mmean_Som_jap/ST_norm_Som_S1_jap$Mmean_Som_mans))/(median(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans))
wilcox.test(((ST_norm_Som_S1_jap$Fmean_Som_jap/ST_norm_Som_S1_jap$Fmean_Som_mans)/(ST_norm_Som_S1_jap$Mmean_Som_jap/ST_norm_Som_S1_jap$Mmean_Som_mans)),((ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans)/(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans)))$p.value

# Japonicum: adults
median(ST_norm_Ad_S1_jap$Fmean_Ad_jap/ST_norm_Ad_S1_jap$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans)
wilcox.test((ST_norm_Ad_S1_jap$Fmean_Ad_jap/ST_norm_Ad_S1_jap$Fmean_Ad_mans),(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans))$p.value
median(ST_norm_Ad_S1_jap$Mmean_Ad_jap/ST_norm_Ad_S1_jap$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans)
wilcox.test((ST_norm_Ad_S1_jap$Mmean_Ad_jap/ST_norm_Ad_S1_jap$Mmean_Ad_mans),(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans))$p.value
(median(ST_norm_Ad_S1_jap$Fmean_Ad_jap/ST_norm_Ad_S1_jap$Fmean_Ad_mans)/median(ST_norm_Ad_S1_jap$Mmean_Ad_jap/ST_norm_Ad_S1_jap$Mmean_Ad_mans))/(median(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans))
wilcox.test(((ST_norm_Ad_S1_jap$Fmean_Ad_jap/ST_norm_Ad_S1_jap$Fmean_Ad_mans)/(ST_norm_Ad_S1_jap$Mmean_Ad_jap/ST_norm_Ad_S1_jap$Mmean_Ad_mans)),((ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans)/(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans)))$p.value

#Mansoni: schistosomula
median(ST_norm_Som_S1_mans$Fmean_Som_mans/ST_norm_Som_S1_mans$Fmean_Som_jap)/median(ST_norm_Som_Aut$Fmean_Som_mans/ST_norm_Som_Aut$Fmean_Som_jap)
wilcox.test((ST_norm_Som_S1_mans$Fmean_Som_mans/ST_norm_Som_S1_mans$Fmean_Som_jap),(ST_norm_Som_Aut$Fmean_Som_mans/ST_norm_Som_Aut$Fmean_Som_jap))$p.value
median(ST_norm_Som_S1_mans$Mmean_Som_mans/ST_norm_Som_S1_mans$Mmean_Som_jap)/median(ST_norm_Som_Aut$Mmean_Som_mans/ST_norm_Som_Aut$Mmean_Som_jap)
wilcox.test((ST_norm_Som_S1_mans$Mmean_Som_mans/ST_norm_Som_S1_mans$Mmean_Som_jap),(ST_norm_Som_Aut$Mmean_Som_mans/ST_norm_Som_Aut$Mmean_Som_jap))$p.value
(median(ST_norm_Som_S1_mans$Fmean_Som_mans/ST_norm_Som_S1_mans$Fmean_Som_jap)/median(ST_norm_Som_S1_mans$Mmean_Som_mans/ST_norm_Som_S1_mans$Mmean_Som_jap))/(median(ST_norm_Som_Aut$Fmean_Som_mans/ST_norm_Som_Aut$Fmean_Som_jap)/median(ST_norm_Som_Aut$Mmean_Som_mans/ST_norm_Som_Aut$Mmean_Som_jap))
wilcox.test(((ST_norm_Som_S1_mans$Fmean_Som_mans/ST_norm_Som_S1_mans$Fmean_Som_jap)/(ST_norm_Som_S1_mans$Mmean_Som_mans/ST_norm_Som_S1_mans$Mmean_Som_jap)),((ST_norm_Som_Aut$Fmean_Som_mans/ST_norm_Som_Aut$Fmean_Som_jap)/(ST_norm_Som_Aut$Mmean_Som_mans/ST_norm_Som_Aut$Mmean_Som_jap)))$p.value

#Mansoni: adults
median(ST_norm_Ad_S1_mans$Fmean_Ad_mans/ST_norm_Ad_S1_mans$Fmean_Ad_jap)/median(ST_norm_Ad_Aut$Fmean_Ad_mans/ST_norm_Ad_Aut$Fmean_Ad_jap)
wilcox.test((ST_norm_Ad_S1_mans$Fmean_Ad_mans/ST_norm_Ad_S1_mans$Fmean_Ad_jap),(ST_norm_Ad_Aut$Fmean_Ad_mans/ST_norm_Ad_Aut$Fmean_Ad_jap))$p.value
median(ST_norm_Ad_S1_mans$Mmean_Ad_mans/ST_norm_Ad_S1_mans$Mmean_Ad_jap)/median(ST_norm_Ad_Aut$Mmean_Ad_mans/ST_norm_Ad_Aut$Mmean_Ad_jap)
wilcox.test((ST_norm_Ad_S1_mans$Mmean_Ad_mans/ST_norm_Ad_S1_mans$Mmean_Ad_jap),(ST_norm_Ad_Aut$Mmean_Ad_mans/ST_norm_Ad_Aut$Mmean_Ad_jap))$p.value
(median(ST_norm_Ad_S1_mans$Fmean_Ad_mans/ST_norm_Ad_S1_mans$Fmean_Ad_jap)/median(ST_norm_Ad_S1_mans$Mmean_Ad_mans/ST_norm_Ad_S1_mans$Mmean_Ad_jap))/(median(ST_norm_Ad_Aut$Fmean_Ad_mans/ST_norm_Ad_Aut$Fmean_Ad_jap)/median(ST_norm_Ad_Aut$Mmean_Ad_mans/ST_norm_Ad_Aut$Mmean_Ad_jap))
wilcox.test(((ST_norm_Ad_S1_mans$Fmean_Ad_mans/ST_norm_Ad_S1_mans$Fmean_Ad_jap)/(ST_norm_Ad_S1_mans$Mmean_Ad_mans/ST_norm_Ad_S1_mans$Mmean_Ad_jap)),((ST_norm_Ad_Aut$Fmean_Ad_mans/ST_norm_Ad_Aut$Fmean_Ad_jap)/(ST_norm_Ad_Aut$Mmean_Ad_mans/ST_norm_Ad_Aut$Mmean_Ad_jap)))$p.value

##############################################
#SUPPLEMENTARY FIGURES: Expression per strata#
##############################################

##STATISTICS

#Stat between strata
wilcox.test(ST_norm_Som_S1_jap$Fmean_Som_jap,ST_norm_Som_S0$Fmean_Som_jap)$p.value
wilcox.test(ST_norm_Ad_S1_jap$Fmean_Ad_jap,ST_norm_Ad_S0$Fmean_Ad_jap)$p.value
wilcox.test(ST_norm_Som_S1_mans$Fmean_Som_mans,ST_norm_Som_S0$Fmean_Som_mans)$p.value
wilcox.test(ST_norm_Ad_S1_mans$Fmean_Ad_mans,ST_norm_Ad_S0$Fmean_Ad_mans)$p.value
wilcox.test(ST_norm_Som_S1_jap$Mmean_Som_jap,ST_norm_Som_S0$Mmean_Som_jap)$p.value
wilcox.test(ST_norm_Ad_S1_jap$Mmean_Ad_jap,ST_norm_Ad_S0$Mmean_Ad_jap)$p.value
wilcox.test(ST_norm_Som_S1_mans$Mmean_Som_mans,ST_norm_Som_S0$Mmean_Som_mans)$p.value
wilcox.test(ST_norm_Ad_S1_mans$Mmean_Ad_mans,ST_norm_Ad_S0$Mmean_Ad_mans)$p.value
wilcox.test(ST_norm_Som_S1_jap$FMratio_Som_jap,ST_norm_Som_S0$FMratio_Som_jap)$p.value
wilcox.test(ST_norm_Ad_S1_jap$FMratio_Ad_jap,ST_norm_Ad_S0$FMratio_Ad_jap)$p.value
wilcox.test(ST_norm_Som_S1_mans$FMratio_Som_mans,ST_norm_Som_S0$FMratio_Som_mans)$p.value
wilcox.test(ST_norm_Ad_S1_mans$FMratio_Ad_mans,ST_norm_Ad_S0$FMratio_Ad_mans)$p.value

#Schistosomula
title_som

#Mansoni: schistosomula
wilcox.test(ST_norm_Som_Z_mans$Fmean_Som_mans,ST_norm_Som_Aut$Fmean_Som_mans)$p.value
wilcox.test(ST_norm_Som_S0$Fmean_Som_mans,ST_norm_Som_Aut$Fmean_Som_mans)$p.value
wilcox.test(ST_norm_Som_S1_jap$Fmean_Som_mans,ST_norm_Som_Aut$Fmean_Som_mans)$p.value
wilcox.test(ST_norm_Som_S1_mans$Fmean_Som_mans,ST_norm_Som_Aut$Fmean_Som_mans)$p.value
wilcox.test(ST_norm_Som_PSA$Fmean_Som_mans,ST_norm_Som_Aut$Fmean_Som_mans)$p.value

wilcox.test(ST_norm_Som_Z_mans$Mmean_Som_mans,ST_norm_Som_Aut$Mmean_Som_mans)$p.value
wilcox.test(ST_norm_Som_S0$Mmean_Som_mans,ST_norm_Som_Aut$Mmean_Som_mans)$p.value
wilcox.test(ST_norm_Som_S1_jap$Mmean_Som_mans,ST_norm_Som_Aut$Mmean_Som_mans)$p.value
wilcox.test(ST_norm_Som_S1_mans$Mmean_Som_mans,ST_norm_Som_Aut$Mmean_Som_mans)$p.value
wilcox.test(ST_norm_Som_PSA$Mmean_Som_mans,ST_norm_Som_Aut$Mmean_Som_mans)$p.value

wilcox.test(ST_norm_Som_Z_mans$FMratio_Som_mans,ST_norm_Som_Aut$FMratio_Som_mans)$p.value
wilcox.test(ST_norm_Som_S0$FMratio_Som_mans,ST_norm_Som_Aut$FMratio_Som_mans)$p.value
wilcox.test(ST_norm_Som_S1_jap$FMratio_Som_mans,ST_norm_Som_Aut$FMratio_Som_mans)$p.value
wilcox.test(ST_norm_Som_S1_mans$FMratio_Som_mans,ST_norm_Som_Aut$FMratio_Som_mans)$p.value
wilcox.test(ST_norm_Som_PSA$FMratio_Som_mans,ST_norm_Som_Aut$FMratio_Som_mans)$p.value

#Japonicum: schistosomula
wilcox.test(ST_norm_Som_Z_jap$Fmean_Som_jap,ST_norm_Som_Aut$Fmean_Som_jap)$p.value
wilcox.test(ST_norm_Som_S0$Fmean_Som_jap,ST_norm_Som_Aut$Fmean_Som_jap)$p.value
wilcox.test(ST_norm_Som_S1_jap$Fmean_Som_jap,ST_norm_Som_Aut$Fmean_Som_jap)$p.value
wilcox.test(ST_norm_Som_S1_mans$Fmean_Som_jap,ST_norm_Som_Aut$Fmean_Som_jap)$p.value
wilcox.test(ST_norm_Som_PSA$Fmean_Som_jap,ST_norm_Som_Aut$Fmean_Som_jap)$p.value

wilcox.test(ST_norm_Som_Z_jap$Mmean_Som_jap,ST_norm_Som_Aut$Mmean_Som_jap)$p.value
wilcox.test(ST_norm_Som_S0$Mmean_Som_jap,ST_norm_Som_Aut$Mmean_Som_jap)$p.value
wilcox.test(ST_norm_Som_S1_jap$Mmean_Som_jap,ST_norm_Som_Aut$Mmean_Som_jap)$p.value
wilcox.test(ST_norm_Som_S1_mans$Mmean_Som_jap,ST_norm_Som_Aut$Mmean_Som_jap)$p.value
wilcox.test(ST_norm_Som_PSA$Mmean_Som_jap,ST_norm_Som_Aut$Mmean_Som_jap)$p.value

wilcox.test(ST_norm_Som_Z_jap$FMratio_Som_jap,ST_norm_Som_Aut$FMratio_Som_jap)$p.value
wilcox.test(ST_norm_Som_S0$FMratio_Som_jap,ST_norm_Som_Aut$FMratio_Som_jap)$p.value
wilcox.test(ST_norm_Som_S1_jap$FMratio_Som_jap,ST_norm_Som_Aut$FMratio_Som_jap)$p.value
wilcox.test(ST_norm_Som_S1_mans$FMratio_Som_jap,ST_norm_Som_Aut$FMratio_Som_jap)$p.value
wilcox.test(ST_norm_Som_PSA$FMratio_Som_jap,ST_norm_Som_Aut$FMratio_Som_jap)$p.value

#Ancestry schistosomula
wilcox.test((ST_norm_Som_Z_jap$Fmean_Som_jap/ST_norm_Som_Z_jap$Fmean_Som_mans),(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans))$p.value
wilcox.test((ST_norm_Som_Z_mans$Fmean_Som_jap/ST_norm_Som_Z_mans$Fmean_Som_mans),(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans))$p.value
wilcox.test((ST_norm_Som_S0$Fmean_Som_jap/ST_norm_Som_S0$Fmean_Som_mans),(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans))$p.value
wilcox.test((ST_norm_Som_S1_jap$Fmean_Som_jap/ST_norm_Som_S1_jap$Fmean_Som_mans),(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans))$p.value
wilcox.test((ST_norm_Som_S1_mans$Fmean_Som_jap/ST_norm_Som_S1_mans$Fmean_Som_mans),(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans))$p.value
wilcox.test((ST_norm_Som_PSA$Fmean_Som_jap/ST_norm_Som_PSA$Fmean_Som_mans),(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans))$p.value

wilcox.test((ST_norm_Som_Z_jap$Mmean_Som_jap/ST_norm_Som_Z_jap$Mmean_Som_mans),(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans))$p.value
wilcox.test((ST_norm_Som_Z_mans$Mmean_Som_jap/ST_norm_Som_Z_mans$Mmean_Som_mans),(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans))$p.value
wilcox.test((ST_norm_Som_S0$Mmean_Som_jap/ST_norm_Som_S0$Mmean_Som_mans),(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans))$p.value
wilcox.test((ST_norm_Som_S1_jap$Mmean_Som_jap/ST_norm_Som_S1_jap$Mmean_Som_mans),(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans))$p.value
wilcox.test((ST_norm_Som_S1_mans$Mmean_Som_jap/ST_norm_Som_S1_mans$Mmean_Som_mans),(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans))$p.value
wilcox.test((ST_norm_Som_PSA$Mmean_Som_jap/ST_norm_Som_PSA$Mmean_Som_mans),(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans))$p.value

wilcox.test((ST_norm_Som_Z_jap$FMratio_Som_jap/ST_norm_Som_Z_jap$FMratio_Som_mans),(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans))$p.value
wilcox.test((ST_norm_Som_Z_mans$FMratio_Som_jap/ST_norm_Som_Z_mans$FMratio_Som_mans),(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans))$p.value
wilcox.test((ST_norm_Som_S0$FMratio_Som_jap/ST_norm_Som_S0$FMratio_Som_mans),(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans))$p.value
wilcox.test((ST_norm_Som_S1_jap$FMratio_Som_jap/ST_norm_Som_S1_jap$FMratio_Som_mans),(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans))$p.value
wilcox.test((ST_norm_Som_S1_mans$FMratio_Som_jap/ST_norm_Som_S1_mans$FMratio_Som_mans),(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans))$p.value
wilcox.test((ST_norm_Som_PSA$FMratio_Som_jap/ST_norm_Som_PSA$FMratio_Som_mans),(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans))$p.value


#Adults
title_ad

#Mansoni: adults
wilcox.test(ST_norm_Ad_Z_mans$Fmean_Ad_mans,ST_norm_Ad_Aut$Fmean_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_S0$Fmean_Ad_mans,ST_norm_Ad_Aut$Fmean_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_S1_jap$Fmean_Ad_mans,ST_norm_Ad_Aut$Fmean_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_S1_mans$Fmean_Ad_mans,ST_norm_Ad_Aut$Fmean_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_PSA$Fmean_Ad_mans,ST_norm_Ad_Aut$Fmean_Ad_mans)$p.value

wilcox.test(ST_norm_Ad_Z_mans$Mmean_Ad_mans,ST_norm_Ad_Aut$Mmean_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_S0$Mmean_Ad_mans,ST_norm_Ad_Aut$Mmean_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_S1_jap$Mmean_Ad_mans,ST_norm_Ad_Aut$Mmean_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_S1_mans$Mmean_Ad_mans,ST_norm_Ad_Aut$Mmean_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_PSA$Mmean_Ad_mans,ST_norm_Ad_Aut$Mmean_Ad_mans)$p.value

wilcox.test(ST_norm_Ad_Z_mans$FMratio_Ad_mans,ST_norm_Ad_Aut$FMratio_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_S0$FMratio_Ad_mans,ST_norm_Ad_Aut$FMratio_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_S1_jap$FMratio_Ad_mans,ST_norm_Ad_Aut$FMratio_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_S1_mans$FMratio_Ad_mans,ST_norm_Ad_Aut$FMratio_Ad_mans)$p.value
wilcox.test(ST_norm_Ad_PSA$FMratio_Ad_mans,ST_norm_Ad_Aut$FMratio_Ad_mans)$p.value

#Japonicum: adults
wilcox.test(ST_norm_Ad_Z_jap$Fmean_Ad_jap,ST_norm_Ad_Aut$Fmean_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_S0$Fmean_Ad_jap,ST_norm_Ad_Aut$Fmean_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_S1_jap$Fmean_Ad_jap,ST_norm_Ad_Aut$Fmean_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_S1_mans$Fmean_Ad_jap,ST_norm_Ad_Aut$Fmean_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_PSA$Fmean_Ad_jap,ST_norm_Ad_Aut$Fmean_Ad_jap)$p.value

wilcox.test(ST_norm_Ad_Z_jap$Mmean_Ad_jap,ST_norm_Ad_Aut$Mmean_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_S0$Mmean_Ad_jap,ST_norm_Ad_Aut$Mmean_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_S1_jap$Mmean_Ad_jap,ST_norm_Ad_Aut$Mmean_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_S1_mans$Mmean_Ad_jap,ST_norm_Ad_Aut$Mmean_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_PSA$Mmean_Ad_jap,ST_norm_Ad_Aut$Mmean_Ad_jap)$p.value

wilcox.test(ST_norm_Ad_Z_jap$FMratio_Ad_jap,ST_norm_Ad_Aut$FMratio_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_S0$FMratio_Ad_jap,ST_norm_Ad_Aut$FMratio_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_S1_jap$FMratio_Ad_jap,ST_norm_Ad_Aut$FMratio_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_S1_mans$FMratio_Ad_jap,ST_norm_Ad_Aut$FMratio_Ad_jap)$p.value
wilcox.test(ST_norm_Ad_PSA$FMratio_Ad_jap,ST_norm_Ad_Aut$FMratio_Ad_jap)$p.value

#Ancestry adults
wilcox.test((ST_norm_Ad_Z_jap$Fmean_Ad_jap/ST_norm_Ad_Z_jap$Fmean_Ad_mans),(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_Z_mans$Fmean_Ad_jap/ST_norm_Ad_Z_mans$Fmean_Ad_mans),(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_S0$Fmean_Ad_jap/ST_norm_Ad_S0$Fmean_Ad_mans),(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_S1_jap$Fmean_Ad_jap/ST_norm_Ad_S1_jap$Fmean_Ad_mans),(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_S1_mans$Fmean_Ad_jap/ST_norm_Ad_S1_mans$Fmean_Ad_mans),(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_PSA$Fmean_Ad_jap/ST_norm_Ad_PSA$Fmean_Ad_mans),(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans))$p.value

wilcox.test((ST_norm_Ad_Z_jap$Mmean_Ad_jap/ST_norm_Ad_Z_jap$Mmean_Ad_mans),(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_Z_mans$Mmean_Ad_jap/ST_norm_Ad_Z_mans$Mmean_Ad_mans),(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_S0$Mmean_Ad_jap/ST_norm_Ad_S0$Mmean_Ad_mans),(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_S1_jap$Mmean_Ad_jap/ST_norm_Ad_S1_jap$Mmean_Ad_mans),(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_S1_mans$Mmean_Ad_jap/ST_norm_Ad_S1_mans$Mmean_Ad_mans),(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_PSA$Mmean_Ad_jap/ST_norm_Ad_PSA$Mmean_Ad_mans),(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans))$p.value

wilcox.test((ST_norm_Ad_Z_jap$FMratio_Ad_jap/ST_norm_Ad_Z_jap$FMratio_Ad_mans),(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans))$p.value 
wilcox.test((ST_norm_Ad_Z_mans$FMratio_Ad_jap/ST_norm_Ad_Z_mans$FMratio_Ad_mans),(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_S0$FMratio_Ad_jap/ST_norm_Ad_S0$FMratio_Ad_mans),(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans))$p.value 
wilcox.test((ST_norm_Ad_S1_jap$FMratio_Ad_jap/ST_norm_Ad_S1_jap$FMratio_Ad_mans),(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans))$p.value 
wilcox.test((ST_norm_Ad_S1_mans$FMratio_Ad_jap/ST_norm_Ad_S1_mans$FMratio_Ad_mans),(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans))$p.value
wilcox.test((ST_norm_Ad_PSA$FMratio_Ad_jap/ST_norm_Ad_PSA$FMratio_Ad_mans),(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans))$p.value 


##Ratio

#Mansoni: schistosomula
median(ST_norm_Som_Z_mans$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_mans)
median(ST_norm_Som_S0$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_mans)
median(ST_norm_Som_S1_jap$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_mans)
median(ST_norm_Som_S1_mans$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_mans)
median(ST_norm_Som_PSA$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_mans)

median(ST_norm_Som_Z_mans$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_mans)
median(ST_norm_Som_S0$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_mans)
median(ST_norm_Som_S1_jap$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_mans)
median(ST_norm_Som_S1_mans$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_mans)
median(ST_norm_Som_PSA$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_mans)

median(ST_norm_Som_Z_mans$FMratio_Som_mans)/median(ST_norm_Som_Aut$FMratio_Som_mans)
median(ST_norm_Som_S0$FMratio_Som_mans)/median(ST_norm_Som_Aut$FMratio_Som_mans)
median(ST_norm_Som_S1_jap$FMratio_Som_mans)/median(ST_norm_Som_Aut$FMratio_Som_mans)
median(ST_norm_Som_S1_mans$FMratio_Som_mans)/median(ST_norm_Som_Aut$FMratio_Som_mans)
median(ST_norm_Som_PSA$FMratio_Som_mans)/median(ST_norm_Som_Aut$FMratio_Som_mans)

#Japonicum: schistosomula
median(ST_norm_Som_Z_jap$Fmean_Som_jap)/median(ST_norm_Som_Aut$Fmean_Som_jap)
median(ST_norm_Som_S0$Fmean_Som_jap)/median(ST_norm_Som_Aut$Fmean_Som_jap)
median(ST_norm_Som_S1_jap$Fmean_Som_jap)/median(ST_norm_Som_Aut$Fmean_Som_jap)
median(ST_norm_Som_S1_mans$Fmean_Som_jap)/median(ST_norm_Som_Aut$Fmean_Som_jap)
median(ST_norm_Som_PSA$Fmean_Som_jap)/median(ST_norm_Som_Aut$Fmean_Som_jap)

median(ST_norm_Som_Z_jap$Mmean_Som_jap)/median(ST_norm_Som_Aut$Mmean_Som_jap)
median(ST_norm_Som_S0$Mmean_Som_jap)/median(ST_norm_Som_Aut$Mmean_Som_jap)
median(ST_norm_Som_S1_jap$Mmean_Som_jap)/median(ST_norm_Som_Aut$Mmean_Som_jap)
median(ST_norm_Som_S1_mans$Mmean_Som_jap)/median(ST_norm_Som_Aut$Mmean_Som_jap)
median(ST_norm_Som_PSA$Mmean_Som_jap)/median(ST_norm_Som_Aut$Mmean_Som_jap)

median(ST_norm_Som_Z_jap$FMratio_Som_jap)/median(ST_norm_Som_Aut$FMratio_Som_jap)
median(ST_norm_Som_S0$FMratio_Som_jap)/median(ST_norm_Som_Aut$FMratio_Som_jap)
median(ST_norm_Som_S1_jap$FMratio_Som_jap)/median(ST_norm_Som_Aut$FMratio_Som_jap)
median(ST_norm_Som_S1_mans$FMratio_Som_jap)/median(ST_norm_Som_Aut$FMratio_Som_jap)
median(ST_norm_Som_PSA$FMratio_Som_jap)/median(ST_norm_Som_Aut$FMratio_Som_jap)

#Ancestry schistosomula
median(ST_norm_Som_Z_jap$Fmean_Som_jap/ST_norm_Som_Z_jap$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans)
median(ST_norm_Som_Z_mans$Fmean_Som_jap/ST_norm_Som_Z_mans$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans)
median(ST_norm_Som_S0$Fmean_Som_jap/ST_norm_Som_S0$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans)
median(ST_norm_Som_S1_jap$Fmean_Som_jap/ST_norm_Som_S1_jap$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans)
median(ST_norm_Som_S1_mans$Fmean_Som_jap/ST_norm_Som_S1_mans$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans)
median(ST_norm_Som_PSA$Fmean_Som_jap/ST_norm_Som_PSA$Fmean_Som_mans)/median(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans)

median(ST_norm_Som_Z_jap$Mmean_Som_jap/ST_norm_Som_Z_jap$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans)
median(ST_norm_Som_Z_mans$Mmean_Som_jap/ST_norm_Som_Z_mans$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans)
median(ST_norm_Som_S0$Mmean_Som_jap/ST_norm_Som_S0$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans)
median(ST_norm_Som_S1_jap$Mmean_Som_jap/ST_norm_Som_S1_jap$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans)
median(ST_norm_Som_S1_mans$Mmean_Som_jap/ST_norm_Som_S1_mans$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans)
median(ST_norm_Som_PSA$Mmean_Som_jap/ST_norm_Som_PSA$Mmean_Som_mans)/median(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans)

median(ST_norm_Som_Z_jap$FMratio_Som_jap/ST_norm_Som_Z_jap$FMratio_Som_mans)/median(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans)
median(ST_norm_Som_Z_mans$FMratio_Som_jap/ST_norm_Som_Z_mans$FMratio_Som_mans)/median(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans)
median(ST_norm_Som_S0$FMratio_Som_jap/ST_norm_Som_S0$FMratio_Som_mans)/median(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans)
median(ST_norm_Som_S1_jap$FMratio_Som_jap/ST_norm_Som_S1_jap$FMratio_Som_mans)/median(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans)
median(ST_norm_Som_S1_mans$FMratio_Som_jap/ST_norm_Som_S1_mans$FMratio_Som_mans)/median(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans)
median(ST_norm_Som_PSA$FMratio_Som_jap/ST_norm_Som_PSA$FMratio_Som_mans)/median(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans)


#Adults
title_ad

#Mansoni: adults
median(ST_norm_Ad_Z_mans$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_mans)
median(ST_norm_Ad_S0$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_mans)
median(ST_norm_Ad_S1_jap$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_mans)
median(ST_norm_Ad_S1_mans$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_mans)
median(ST_norm_Ad_PSA$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_mans)

median(ST_norm_Ad_Z_mans$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_mans)
median(ST_norm_Ad_S0$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_mans)
median(ST_norm_Ad_S1_jap$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_mans)
median(ST_norm_Ad_S1_mans$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_mans)
median(ST_norm_Ad_PSA$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_mans)

median(ST_norm_Ad_Z_mans$FMratio_Ad_mans)/median(ST_norm_Ad_Aut$FMratio_Ad_mans)
median(ST_norm_Ad_S0$FMratio_Ad_mans)/median(ST_norm_Ad_Aut$FMratio_Ad_mans)
median(ST_norm_Ad_S1_jap$FMratio_Ad_mans)/median(ST_norm_Ad_Aut$FMratio_Ad_mans)
median(ST_norm_Ad_S1_mans$FMratio_Ad_mans)/median(ST_norm_Ad_Aut$FMratio_Ad_mans)
median(ST_norm_Ad_PSA$FMratio_Ad_mans)/median(ST_norm_Ad_Aut$FMratio_Ad_mans)

#Japonicum: adults
median(ST_norm_Ad_Z_jap$Fmean_Ad_jap)/median(ST_norm_Ad_Aut$Fmean_Ad_jap)
median(ST_norm_Ad_S0$Fmean_Ad_jap)/median(ST_norm_Ad_Aut$Fmean_Ad_jap)
median(ST_norm_Ad_S1_jap$Fmean_Ad_jap)/median(ST_norm_Ad_Aut$Fmean_Ad_jap)
median(ST_norm_Ad_S1_mans$Fmean_Ad_jap)/median(ST_norm_Ad_Aut$Fmean_Ad_jap)
median(ST_norm_Ad_PSA$Fmean_Ad_jap)/median(ST_norm_Ad_Aut$Fmean_Ad_jap)

median(ST_norm_Ad_Z_jap$Mmean_Ad_jap)/median(ST_norm_Ad_Aut$Mmean_Ad_jap)
median(ST_norm_Ad_S0$Mmean_Ad_jap)/median(ST_norm_Ad_Aut$Mmean_Ad_jap)
median(ST_norm_Ad_S1_jap$Mmean_Ad_jap)/median(ST_norm_Ad_Aut$Mmean_Ad_jap)
median(ST_norm_Ad_S1_mans$Mmean_Ad_jap)/median(ST_norm_Ad_Aut$Mmean_Ad_jap)
median(ST_norm_Ad_PSA$Mmean_Ad_jap)/median(ST_norm_Ad_Aut$Mmean_Ad_jap)

median(ST_norm_Ad_Z_jap$FMratio_Ad_jap)/median(ST_norm_Ad_Aut$FMratio_Ad_jap)
median(ST_norm_Ad_S0$FMratio_Ad_jap)/median(ST_norm_Ad_Aut$FMratio_Ad_jap)
median(ST_norm_Ad_S1_jap$FMratio_Ad_jap)/median(ST_norm_Ad_Aut$FMratio_Ad_jap)
median(ST_norm_Ad_S1_mans$FMratio_Ad_jap)/median(ST_norm_Ad_Aut$FMratio_Ad_jap)
median(ST_norm_Ad_PSA$FMratio_Ad_jap)/median(ST_norm_Ad_Aut$FMratio_Ad_jap)

#Ancestry adults
median(ST_norm_Ad_Z_jap$Fmean_Ad_jap/ST_norm_Ad_Z_jap$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans)
median(ST_norm_Ad_Z_mans$Fmean_Ad_jap/ST_norm_Ad_Z_mans$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans)
median(ST_norm_Ad_S0$Fmean_Ad_jap/ST_norm_Ad_S0$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans)
median(ST_norm_Ad_S1_jap$Fmean_Ad_jap/ST_norm_Ad_S1_jap$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans)
median(ST_norm_Ad_S1_mans$Fmean_Ad_jap/ST_norm_Ad_S1_mans$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans)
median(ST_norm_Ad_PSA$Fmean_Ad_jap/ST_norm_Ad_PSA$Fmean_Ad_mans)/median(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans)

median(ST_norm_Ad_Z_jap$Mmean_Ad_jap/ST_norm_Ad_Z_jap$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans)
median(ST_norm_Ad_Z_mans$Mmean_Ad_jap/ST_norm_Ad_Z_mans$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans)
median(ST_norm_Ad_S0$Mmean_Ad_jap/ST_norm_Ad_S0$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans)
median(ST_norm_Ad_S1_jap$Mmean_Ad_jap/ST_norm_Ad_S1_jap$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans)
median(ST_norm_Ad_S1_mans$Mmean_Ad_jap/ST_norm_Ad_S1_mans$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans)
median(ST_norm_Ad_PSA$Mmean_Ad_jap/ST_norm_Ad_PSA$Mmean_Ad_mans)/median(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans)

median(ST_norm_Ad_Z_jap$FMratio_Ad_jap/ST_norm_Ad_Z_jap$FMratio_Ad_mans)/median(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans)
median(ST_norm_Ad_Z_mans$FMratio_Ad_jap/ST_norm_Ad_Z_mans$FMratio_Ad_mans)/median(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans)
median(ST_norm_Ad_S0$FMratio_Ad_jap/ST_norm_Ad_S0$FMratio_Ad_mans)/median(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans)
median(ST_norm_Ad_S1_jap$FMratio_Ad_jap/ST_norm_Ad_S1_jap$FMratio_Ad_mans)/median(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans)
median(ST_norm_Ad_S1_mans$FMratio_Ad_jap/ST_norm_Ad_S1_mans$FMratio_Ad_mans)/median(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans)
median(ST_norm_Ad_PSA$FMratio_Ad_jap/ST_norm_Ad_PSA$FMratio_Ad_mans)/median(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans)


##PLOTS
title_som <- "SCHISTOSOMULA - TPM>0 - Strata Method1 (Stringent)"
title_ad <- "ADULTS - TPM>1 - Strata Method1 (Stringent)"

###Schistosomula
par(mfrow=c(3,3), mar=c(3,5,5,1))

ylimin1 <- (-6) ; ylimax1 <- 11 # Min and max value for A, B, D and E
ylimin2 <- (-2) ; ylimax2 <- 2 # Min and max value for C, F and I
ylimin3 <- (-5) ; ylimax3 <- 5 # Min and max value for G and H

#Mansoni
boxplot(log2(ST_norm_Som_S0$Fmean_Som_mans), log2(ST_norm_Som_S1_jap$Fmean_Som_mans), log2(ST_norm_Som_S1_mans$Fmean_Som_mans), log2(ST_norm_Som_PSA$Fmean_Som_mans), log2(ST_norm_Som_Aut$Fmean_Som_mans), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(RPKM)", ylim=c(ylimin1,ylimax1), notch=T, outline = F, col=c("deeppink2","deeppink4","deeppink2","deeppink4","deeppink4"),main="A) Females - S. mansoni")
abline(h=median(log2(ST_norm_Som_Aut$Fmean_Som_mans),na.rm=T), lty=2, lwd=2, col="deeppink4")
text(x=1,y=(ylimax1-0.5),labels="",cex=2) # For the stars indicating significance, please refer to the "Statistics" Excell document (Supplementary File xxx)
text(x=2,y=(ylimax1-0.5),labels="",cex=2)
text(x=3,y=(ylimax1-0.5),labels="",cex=2)
text(x=4,y=(ylimax1-0.5),labels="",cex=2)
boxplot(log2(ST_norm_Som_S0$Mmean_Som_mans), log2(ST_norm_Som_S1_jap$Mmean_Som_mans), log2(ST_norm_Som_S1_mans$Mmean_Som_mans), log2(ST_norm_Som_PSA$Mmean_Som_mans), log2(ST_norm_Som_Aut$Mmean_Som_mans), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(RPKM)", ylim=c(ylimin1,ylimax1), notch=T, outline = F, col=c("royalblue2","royalblue4","royalblue2","royalblue4","royalblue4"), main="B) Males - S. mansoni")
abline(h=median(log2(ST_norm_Som_Aut$Mmean_Som_man),na.rm=T), lty=2, lwd=2, col="royalblue4")
text(x=1,y=(ylimax1-0.5),labels="***",cex=2)
text(x=2,y=(ylimax1-0.5),labels="",cex=2)
text(x=3,y=(ylimax1-0.5),labels="*",cex=2)
text(x=4,y=(ylimax1-0.5),labels="",cex=2)
boxplot(ST_norm_Som_S0$FMlog_Som_mans, ST_norm_Som_S1_jap$FMlog_Som_mans, ST_norm_Som_S1_mans$FMlog_Som_mans, ST_norm_Som_PSA$FMlog_Som_mans, ST_norm_Som_Aut$FMlog_Som_mans, names = c("S0","S1jap","S1mans","PSA","Aut"), ylim=c(ylimin2,ylimax2), ylab="log2(F:M)", notch=T, outline = F, col=c("sienna1","grey","sienna1","grey","grey"), main="C) F:M ratio - S. mansoni")
abline(h=median((ST_norm_Som_Aut$FMlog_Som_mans),na.rm=T),lty=2,lwd=2,col="grey")
text(x=1,y=(ylimax2-0.25),labels="***",cex=2)
text(x=2,y=(ylimax2-0.25),labels="",cex=2)
text(x=3,y=(ylimax2-0.25),labels="***",cex=2)
text(x=4,y=(ylimax2-0.25),labels="",cex=2)
#Japonicum
boxplot(log2(ST_norm_Som_S0$Fmean_Som_jap), log2(ST_norm_Som_S1_jap$Fmean_Som_jap), log2(ST_norm_Som_S1_mans$Fmean_Som_jap), log2(ST_norm_Som_PSA$Fmean_Som_jap), log2(ST_norm_Som_Aut$Fmean_Som_jap), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(RPKM)",ylim=c(ylimin1,ylimax1), notch=T, outline = F, col=c("deeppink2","deeppink2","deeppink4","deeppink4","deeppink4"), main="D) Females - S. japonicum")
abline(h=median(log2(ST_norm_Som_Aut$Fmean_Som_jap),na.rm=T), lty=2, lwd=2, col="deeppink4")
text(x=1,y=(ylimax1-0.5),labels="*",cex=2)
text(x=2,y=(ylimax1-0.5),labels="**",cex=2)
text(x=3,y=(ylimax1-0.5),labels="",cex=2)
text(x=4,y=(ylimax1-0.5),labels="",cex=2)
boxplot(log2(ST_norm_Som_S0$Mmean_Som_jap), log2(ST_norm_Som_S1_jap$Mmean_Som_jap), log2(ST_norm_Som_S1_mans$Mmean_Som_jap), log2(ST_norm_Som_PSA$Mmean_Som_jap), log2(ST_norm_Som_Aut$Mmean_Som_jap), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(RPKM)",ylim=c(ylimin1,ylimax1), notch=T, outline = F, col=c("royalblue2","royalblue2","royalblue4","royalblue4","royalblue4"), main="E) Males - S. japonicum")
abline(h=median(log2(ST_norm_Som_Aut$Mmean_Som_jap),na.rm=T), lty=2, lwd=2, col="royalblue4")
text(x=1,y=(ylimax1-0.5),labels="*",cex=2)
text(x=2,y=(ylimax1-0.5),labels="",cex=2)
text(x=3,y=(ylimax1-0.5),labels="",cex=2)
text(x=4,y=(ylimax1-0.5),labels="",cex=2)
boxplot(ST_norm_Som_S0$FMlog_Som_jap, ST_norm_Som_S1_jap$FMlog_Som_jap, ST_norm_Som_S1_mans$FMlog_Som_jap, ST_norm_Som_PSA$FMlog_Som_jap, ST_norm_Som_Aut$FMlog_Som_jap, names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(F:M)", ylim=c(ylimin2,ylimax2), notch=T, outline = F, col=c("sienna1","sienna1","grey","grey","grey","grey"), main="F) F:M ratio - S. japonicum")
abline(h=median(ST_norm_Som_Aut$FMlog_Som_jap,na.rm=T), lty=2, lwd=2, col="grey")
text(x=1,y=(ylimax2-0.25),labels="***",cex=2)
text(x=2,y=(ylimax2-0.25),labels="***",cex=2)
text(x=3,y=(ylimax2-0.25),labels="",cex=2)
text(x=4,y=(ylimax2-0.25),labels="",cex=2)
#RATIO Jap/Mans
boxplot(log2(ST_norm_Som_S0$Fmean_Som_jap/ST_norm_Som_S0$Fmean_Som_mans), log2(ST_norm_Som_S1_jap$Fmean_Som_jap/ST_norm_Som_S1_jap$Fmean_Som_mans), log2(ST_norm_Som_S1_mans$Fmean_Som_jap/ST_norm_Som_S1_mans$Fmean_Som_mans), log2(ST_norm_Som_PSA$Fmean_Som_jap/ST_norm_Som_PSA$Fmean_Som_mans),log2(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(S.jap:S.mans)", ylim=c(ylimin3,ylimax3),notch=T, outline = F, col=c("deeppink4","deeppink2","deeppink2","deeppink4","deeppink4"), main="G) Females - S.jap:S.mans")
abline(h=median(log2(ST_norm_Som_Aut$Fmean_Som_jap/ST_norm_Som_Aut$Fmean_Som_mans),na.rm=T), lty=2, lwd=2, col="deeppink4")
text(x=1,y=(ylimax3-0.5),labels="",cex=2)
text(x=2,y=(ylimax3-0.5),labels="**",cex=2)
text(x=3,y=(ylimax3-0.5),labels="",cex=2)
text(x=4,y=(ylimax3-0.5),labels="",cex=2)
boxplot(log2(ST_norm_Som_S0$Mmean_Som_jap/ST_norm_Som_S0$Mmean_Som_mans), log2(ST_norm_Som_S1_jap$Mmean_Som_jap/ST_norm_Som_S1_jap$Mmean_Som_mans), log2(ST_norm_Som_S1_mans$Mmean_Som_jap/ST_norm_Som_S1_mans$Mmean_Som_mans), log2(ST_norm_Som_PSA$Mmean_Som_jap/ST_norm_Som_PSA$Mmean_Som_mans),log2(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(S.jap:S.mans)", ylim=c(ylimin3,ylimax3), notch=T, outline = F, col=c("royalblue4","royalblue2","royalblue2","royalblue4","royalblue4"), main="H) Males - S.jap:S.mans")
abline(h=median(log2(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans),na.rm=T), lty=2, lwd=2, col="royalblue4")
text(x=1,y=(ylimax3-0.5),labels="",cex=2)
text(x=2,y=(ylimax3-0.5),labels="",cex=2)
text(x=3,y=(ylimax3-0.5),labels="",cex=2)
text(x=4,y=(ylimax3-0.5),labels="",cex=2)
boxplot(log2(ST_norm_Som_S0$FMratio_Som_jap/ST_norm_Som_S0$FMratio_Som_mans), log2(ST_norm_Som_S1_jap$FMratio_Som_jap/ST_norm_Som_S1_jap$FMratio_Som_mans),log2(ST_norm_Som_S1_mans$FMratio_Som_jap/ST_norm_Som_S1_mans$FMratio_Som_mans), log2(ST_norm_Som_PSA$FMratio_Som_jap/ST_norm_Som_PSA$FMratio_Som_mans),log2(ST_norm_Som_Aut$FMratio_Som_jap/ST_norm_Som_Aut$FMratio_Som_mans), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(S.jap:S.mans)", ylim=c(ylimin2,ylimax2), notch=T, outline = F, col=c("grey","sienna1","sienna1","grey","grey"), main="I) F:M ratio - S.jap:S.mans")
abline(h=median(log2(ST_norm_Som_Aut$Mmean_Som_jap/ST_norm_Som_Aut$Mmean_Som_mans),na.rm=T), lty=2, lwd=2, col="grey")
text(x=1,y=(ylimax2-0.25),labels="",cex=2)
text(x=2,y=(ylimax2-0.25),labels="***",cex=2)
text(x=3,y=(ylimax2-0.25),labels="***",cex=2)
text(x=4,y=(ylimax2-0.25),labels="",cex=2)

#Title
mtext(title_som, outer=TRUE,  cex=1, line=-1.5, col="grey")

###Adults
par(mfrow=c(3,3), mar=c(3,5,5,1))
ylimin1 <- (-0.5) ; ylimax1 <- 11 # Min and max value for A, B, D and E
ylimin2 <- (-3) ; ylimax2 <- 4 # Min and max value for C, F and I
ylimin3 <- (-4.5) ; ylimax3 <- 4.5 # Min and max value for G and H

#Mansoni
boxplot(log2(ST_norm_Ad_S0$Fmean_Ad_mans), log2(ST_norm_Ad_S1_jap$Fmean_Ad_mans), log2(ST_norm_Ad_S1_mans$Fmean_Ad_mans), log2(ST_norm_Ad_PSA$Fmean_Ad_mans), log2(ST_norm_Ad_Aut$Fmean_Ad_mans), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(RPKM)",ylim=c(ylimin1,ylimax1), notch=T, outline = F, col=c("deeppink2","deeppink4","deeppink2","deeppink4","deeppink4"),main="A) Females - S. mansoni")
abline(h=median(log2(ST_norm_Ad_Aut$Fmean_Ad_mans),na.rm=T), lty=2, lwd=2, col="deeppink4")
text(x=1,y=(ylimax1-0.5),labels="",cex=2)
text(x=2,y=(ylimax1-0.5),labels="",cex=2)
text(x=3,y=(ylimax1-0.5),labels="",cex=2)
text(x=4,y=(ylimax1-0.5),labels="",cex=2)
boxplot(log2(ST_norm_Ad_S0$Mmean_Ad_mans), log2(ST_norm_Ad_S1_jap$Mmean_Ad_mans), log2(ST_norm_Ad_S1_mans$Mmean_Ad_mans), log2(ST_norm_Ad_PSA$Mmean_Ad_mans), log2(ST_norm_Ad_Aut$Mmean_Ad_mans), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(RPKM)",ylim=c(ylimin1,ylimax1), notch=T, outline = F, col=c("royalblue2","royalblue4","royalblue2","royalblue4","royalblue4"), main="B) Males - S. mansoni")
abline(h=median(log2(ST_norm_Ad_Aut$Mmean_Ad_man),na.rm=T), lty=2, lwd=2, col="royalblue4")
text(x=1,y=(ylimax1-0.5),labels="***",cex=2)
text(x=2,y=(ylimax1-0.5),labels="",cex=2)
text(x=3,y=(ylimax1-0.5),labels="*",cex=2)
text(x=4,y=(ylimax1-0.5),labels="",cex=2)
boxplot(ST_norm_Ad_S0$FMlog_Ad_mans, ST_norm_Ad_S1_jap$FMlog_Ad_mans, ST_norm_Ad_S1_mans$FMlog_Ad_mans, ST_norm_Ad_PSA$FMlog_Ad_mans, ST_norm_Ad_Aut$FMlog_Ad_mans, names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(F:M)",ylim=c(ylimin2,ylimax2), notch=T, outline = F, col=c("sienna1","grey","sienna1","grey","grey"), main="C) F:M ratio - S. mansoni")
abline(h=median((ST_norm_Ad_Aut$FMlog_Ad_mans),na.rm=T),lty=2,lwd=2,col="grey")
text(x=1,y=(ylimax2-0.25),labels="***",cex=2)
text(x=2,y=(ylimax2-0.25),labels="",cex=2)
text(x=3,y=(ylimax2-0.25),labels="***",cex=2)
text(x=4,y=(ylimax2-0.25),labels="",cex=2)
#Japonicum
boxplot(log2(ST_norm_Ad_S0$Fmean_Ad_jap), log2(ST_norm_Ad_S1_jap$Fmean_Ad_jap), log2(ST_norm_Ad_S1_mans$Fmean_Ad_jap), log2(ST_norm_Ad_PSA$Fmean_Ad_jap), log2(ST_norm_Ad_Aut$Fmean_Ad_jap), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(RPKM)",ylim=c(ylimin1,ylimax1), notch=T, outline = F, col=c("deeppink2","deeppink2","deeppink4","deeppink4","deeppink4"), main="D) Females - S. japonicum")
abline(h=median(log2(ST_norm_Ad_Aut$Fmean_Ad_jap),na.rm=T), lty=2, lwd=2, col="deeppink4")
text(x=1,y=(ylimax1-0.5),labels="*",cex=2)
text(x=2,y=(ylimax1-0.5),labels="**",cex=2)
text(x=3,y=(ylimax1-0.5),labels="",cex=2)
text(x=4,y=(ylimax1-0.5),labels="",cex=2)
boxplot(log2(ST_norm_Ad_S0$Mmean_Ad_jap), log2(ST_norm_Ad_S1_jap$Mmean_Ad_jap), log2(ST_norm_Ad_S1_mans$Mmean_Ad_jap), log2(ST_norm_Ad_PSA$Mmean_Ad_jap), log2(ST_norm_Ad_Aut$Mmean_Ad_jap), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(RPKM)",ylim=c(ylimin1,ylimax1), notch=T, outline = F, col=c("royalblue2","royalblue2","royalblue4","royalblue4","royalblue4"), main="E) Males - S. japonicum")
abline(h=median(log2(ST_norm_Ad_Aut$Mmean_Ad_jap),na.rm=T), lty=2, lwd=2, col="royalblue4")
text(x=1,y=(ylimax1-0.5),labels="*",cex=2)
text(x=2,y=(ylimax1-0.5),labels="",cex=2)
text(x=3,y=(ylimax1-0.5),labels="",cex=2)
text(x=4,y=(ylimax1-0.5),labels="",cex=2)
boxplot(ST_norm_Ad_S0$FMlog_Ad_jap, ST_norm_Ad_S1_jap$FMlog_Ad_jap, ST_norm_Ad_S1_mans$FMlog_Ad_jap, ST_norm_Ad_PSA$FMlog_Ad_jap, ST_norm_Ad_Aut$FMlog_Ad_jap, names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(F:M)",ylim=c(ylimin2,ylimax2),notch=T, outline = F, col=c("sienna1","sienna1","grey","grey","grey","grey"), main="F) F:M ratio - S. japonicum")
abline(h=median(ST_norm_Ad_Aut$FMlog_Ad_jap,na.rm=T), lty=2, lwd=2, col="grey")
text(x=1,y=(ylimax2-0.25),labels="***",cex=2)
text(x=2,y=(ylimax2-0.25),labels="***",cex=2)
text(x=3,y=(ylimax2-0.25),labels="",cex=2)
text(x=4,y=(ylimax2-0.25),labels="",cex=2)
#RATIO Jap/Mans
boxplot(log2(ST_norm_Ad_S0$Fmean_Ad_jap/ST_norm_Ad_S0$Fmean_Ad_mans), log2(ST_norm_Ad_S1_jap$Fmean_Ad_jap/ST_norm_Ad_S1_jap$Fmean_Ad_mans), log2(ST_norm_Ad_S1_mans$Fmean_Ad_jap/ST_norm_Ad_S1_mans$Fmean_Ad_mans), log2(ST_norm_Ad_PSA$Fmean_Ad_jap/ST_norm_Ad_PSA$Fmean_Ad_mans),log2(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(S.jap:S.mans)",ylim=c(ylimin3,ylimax3), notch=T, outline = F, col=c("deeppink4","deeppink2","deeppink2","deeppink4","deeppink4"), main="G) Females - S.jap:S.mans")
abline(h=median(log2(ST_norm_Ad_Aut$Fmean_Ad_jap/ST_norm_Ad_Aut$Fmean_Ad_mans),na.rm=T), lty=2, lwd=2, col="deeppink4")
text(x=1,y=(ylimax3-0.5),labels="",cex=2)
text(x=2,y=(ylimax3-0.5),labels="**",cex=2)
text(x=3,y=(ylimax3-0.5),labels="",cex=2)
text(x=4,y=(ylimax3-0.5),labels="",cex=2)
boxplot(log2(ST_norm_Ad_S0$Mmean_Ad_jap/ST_norm_Ad_S0$Mmean_Ad_mans), log2(ST_norm_Ad_S1_jap$Mmean_Ad_jap/ST_norm_Ad_S1_jap$Mmean_Ad_mans), log2(ST_norm_Ad_S1_mans$Mmean_Ad_jap/ST_norm_Ad_S1_mans$Mmean_Ad_mans), log2(ST_norm_Ad_PSA$Mmean_Ad_jap/ST_norm_Ad_PSA$Mmean_Ad_mans),log2(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(S.jap:S.mans)", ylim=c(ylimin3,ylimax3), notch=T, outline = F, col=c("royalblue4","royalblue2","royalblue2","royalblue4","royalblue4"), main="H) Males - S.jap:S.mans")
abline(h=median(log2(ST_norm_Ad_Aut$Mmean_Ad_jap/ST_norm_Ad_Aut$Mmean_Ad_mans),na.rm=T), lty=2, lwd=2, col="royalblue4")
text(x=1,y=(ylimax3-0.5),labels="",cex=2)
text(x=2,y=(ylimax3-0.5),labels="",cex=2)
text(x=3,y=(ylimax3-0.5),labels="",cex=2)
text(x=4,y=(ylimax3-0.5),labels="",cex=2)
boxplot(log2(ST_norm_Ad_S0$FMratio_Ad_jap/ST_norm_Ad_S0$FMratio_Ad_mans), log2(ST_norm_Ad_S1_jap$FMratio_Ad_jap/ST_norm_Ad_S1_jap$FMratio_Ad_mans),log2(ST_norm_Ad_S1_mans$FMratio_Ad_jap/ST_norm_Ad_S1_mans$FMratio_Ad_mans), log2(ST_norm_Ad_PSA$FMratio_Ad_jap/ST_norm_Ad_PSA$FMratio_Ad_mans),log2(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans), names = c("S0","S1jap","S1mans","PSA","Aut"), ylab="log2(S.jap:S.mans)",ylim=c(ylimin2,ylimax2), notch=T, outline = F, col=c("grey","sienna1","sienna1","grey","grey"), main="I) F:M ratio - S.jap:S.mans")
abline(h=median(log2(ST_norm_Ad_Aut$FMratio_Ad_jap/ST_norm_Ad_Aut$FMratio_Ad_mans),na.rm=T), lty=2, lwd=2, col="grey")
text(x=1,y=(ylimax2-0.25),labels="",cex=2)
text(x=2,y=(ylimax2-0.25),labels="***",cex=2)
text(x=3,y=(ylimax2-0.25),labels="***",cex=2)
text(x=4,y=(ylimax2-0.25),labels="",cex=2)

#Title
mtext(title_ad, outer=TRUE,  cex=1, line=-1.5, col="grey")

#######################################
# EXPRESSION DEPENDING ON INTERACTION #
#######################################

## Subset tables

# Total number of interactions (excluding co-expression data)
# Adults - S. mansoni
ST_norm_Ad_Z_mans_noint <- subset(ST_norm_Ad_Z_mans, TotalPPIs_exp=0)
nrow(ST_norm_Ad_Z_mans_noint) #375
ST_norm_Ad_Z_mans_PPI<- subset(ST_norm_Ad_Z_mans, TotalPPIs_exp>=1)
nrow(ST_norm_Ad_Z_mans_PPI) #32
# Adults - S. japonicum
ST_norm_Ad_Z_jap_noint <- subset(ST_norm_Ad_Z_jap, TotalPPIs_exp=0)
nrow(ST_norm_Ad_Z_jap_noint) #305
ST_norm_Ad_Z_jap_PPI<- subset(ST_norm_Ad_Z_jap, TotalPPIs_exp>=1)
nrow(ST_norm_Ad_Z_jap_PPI) #30
# Adults - Autosomes
ST_norm_Ad_Aut_noint <- subset(ST_norm_Ad_Aut, TotalPPIs_exp=0)
nrow(ST_norm_Ad_Aut_noint) #2134
ST_norm_Ad_Aut_PPI<- subset(ST_norm_Ad_Aut, TotalPPIs_exp>=1)
nrow(ST_norm_Ad_Aut_PPI)  #196
# Schistosomula - S. mansoni
ST_norm_Som_Z_mans_noint <- subset(ST_norm_Som_Z_mans, TotalPPIs_exp=0)
nrow(ST_norm_Som_Z_mans_noint) #375
ST_norm_Som_Z_mans_PPI<- subset(ST_norm_Som_Z_mans, TotalPPIs_exp>=1)
nrow(ST_norm_Som_Z_mans_PPI) #32
# Schistosomula - S. japonicum
ST_norm_Som_Z_jap_noint <- subset(ST_norm_Som_Z_jap, TotalPPIs_exp=0)
nrow(ST_norm_Som_Z_jap_noint) #305
ST_norm_Som_Z_jap_PPI<- subset(ST_norm_Som_Z_jap, TotalPPIs_exp>=1)
nrow(ST_norm_Som_Z_jap_PPI) #30
# Schistosomula - Autosomes
ST_norm_Som_Aut_noint <- subset(ST_norm_Som_Aut, TotalPPIs_exp=0)
nrow(ST_norm_Som_Aut_noint) #2134
ST_norm_Som_Aut_PPI<- subset(ST_norm_Som_Aut, TotalPPIs_exp>=1)
nrow(ST_norm_Som_Aut_PPI) #196

## Plots

# With or without PPIs 
layout(matrix(c(1,1,2,2,3,3,4,4), 1, 8, byrow = TRUE))
par(mar=c(3,5,5,1))
boxplot(ST_norm_Som_Z_jap_noint$FMlog_Som_jap,ST_norm_Som_Aut_noint$FMlog_Som_jap,ST_norm_Som_Z_jap_PPI$FMlog_Som_jap,ST_norm_Som_Aut_PPI$FMlog_Som_jap, names = c("Z_woINT","A_woINT","Z_PPI","A_PPI"), ylab="log2(F:M)",cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey","sienna1","grey"), main="A. S.jap SCHISTOSOMULA")
abline(v = 2.5)
boxplot(ST_norm_Ad_Z_jap_noint$FMlog_Ad_jap,ST_norm_Ad_Aut_noint$FMlog_Ad_jap,ST_norm_Ad_Z_jap_PPI$FMlog_Ad_jap,ST_norm_Ad_Aut_PPI$FMlog_Ad_jap, names = c("Z_woINT","A_woINT","Z_PPI","A_PPI"), ylab="log2(F:M)",cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey","sienna1","grey"), main="B. S.jap ADULTS")
abline(v = 2.5)
boxplot(ST_norm_Som_Z_mans_noint$FMlog_Som_mans,ST_norm_Som_Aut_noint$FMlog_Som_mans,ST_norm_Som_Z_mans_PPI$FMlog_Som_mans,ST_norm_Som_Aut_PPI$FMlog_Som_mans, names = c("Z_woINT","A_woINT","Z_PPI","A_PPI"), ylab="log2(F:M)",cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey","sienna1","grey"), main="C. S.mans SCHISTOSOMULA")
abline(v = 2.5)
boxplot(ST_norm_Ad_Z_mans_noint$FMlog_Ad_mans,ST_norm_Ad_Aut_noint$FMlog_Ad_mans,ST_norm_Ad_Z_mans_PPI$FMlog_Ad_mans,ST_norm_Ad_Aut_PPI$FMlog_Ad_mans, names = c("Z_woINT","A_woINT","Z_PPI","A_PPI"), ylab="log2(F:M)",cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey","sienna1","grey"), main="D. S.mans ADULTS")
abline(v = 2.5)

wilcox.test(ST_norm_Som_Z_jap_noint$FMratio_Som_jap,ST_norm_Som_Aut_noint$FMratio_Som_jap)$p.value
median(ST_norm_Som_Z_jap_noint$FMratio_Som_jap) / median(ST_norm_Som_Aut_noint$FMratio_Som_jap)
wilcox.test(ST_norm_Som_Z_jap_PPI$FMratio_Som_jap,ST_norm_Som_Aut_PPI$FMratio_Som_jap)$p.value
median(ST_norm_Som_Z_jap_PPI$FMratio_Som_jap) / median(ST_norm_Som_Aut_PPI$FMratio_Som_jap)

wilcox.test(ST_norm_Ad_Z_jap_noint$FMratio_Ad_jap,ST_norm_Ad_Aut_noint$FMratio_Ad_jap)$p.value
median(ST_norm_Ad_Z_jap_noint$FMratio_Ad_jap) / median(ST_norm_Ad_Aut_noint$FMratio_Ad_jap)
wilcox.test(ST_norm_Ad_Z_jap_PPI$FMratio_Ad_jap,ST_norm_Ad_Aut_PPI$FMratio_Ad_jap)$p.value
median(ST_norm_Ad_Z_jap_PPI$FMratio_Ad_jap) / median(ST_norm_Ad_Aut_PPI$FMratio_Ad_jap)

wilcox.test(ST_norm_Som_Z_mans_noint$FMratio_Som_mans,ST_norm_Som_Aut_noint$FMratio_Som_mans)$p.value
median(ST_norm_Som_Z_mans_noint$FMratio_Som_mans) / median(ST_norm_Som_Aut_noint$FMratio_Som_mans)
wilcox.test(ST_norm_Som_Z_mans_PPI$FMratio_Som_mans,ST_norm_Som_Aut_PPI$FMratio_Som_mans)$p.value
median(ST_norm_Som_Z_mans_PPI$FMratio_Som_mans) / median(ST_norm_Som_Aut_PPI$FMratio_Som_mans)

wilcox.test(ST_norm_Ad_Z_mans_noint$FMratio_Ad_mans,ST_norm_Ad_Aut_noint$FMratio_Ad_mans)$p.value
median(ST_norm_Ad_Z_mans_noint$FMratio_Ad_mans) / median(ST_norm_Ad_Aut_noint$FMratio_Ad_mans)
wilcox.test(ST_norm_Ad_Z_mans_PPI$FMratio_Ad_mans,ST_norm_Ad_Aut_PPI$FMratio_Ad_mans)$p.value
median(ST_norm_Ad_Z_mans_PPI$FMratio_Ad_mans) / median(ST_norm_Ad_Aut_PPI$FMratio_Ad_mans)

# With + or -, or without PPIs 
# Adults - S. mansoni
ST_norm_Ad_Z_mans_noint <- subset(ST_norm_Ad_Z_mans, TotalPPIs_exp=0)
nrow(ST_norm_Ad_Z_mans_noint) #375
ST_norm_Ad_Z_mans_PPI<- subset(ST_norm_Ad_Z_mans, TotalPPIs_exp>=1 & TotalPPIs_exp<10)
nrow(ST_norm_Ad_Z_mans_PPI) #15
ST_norm_Ad_Z_mans_PPImore<- subset(ST_norm_Ad_Z_mans, TotalPPIs_exp>=10)
nrow(ST_norm_Ad_Z_mans_PPImore) #17
# Adults - S. japonicum
ST_norm_Ad_Z_jap_noint <- subset(ST_norm_Ad_Z_jap, TotalPPIs_exp=0)
nrow(ST_norm_Ad_Z_jap_noint) #305
ST_norm_Ad_Z_jap_PPI<- subset(ST_norm_Ad_Z_jap, TotalPPIs_exp>=1 & TotalPPIs_exp<10)
nrow(ST_norm_Ad_Z_jap_PPI) #15
ST_norm_Ad_Z_jap_PPImore<- subset(ST_norm_Ad_Z_jap, TotalPPIs_exp>=10)
nrow(ST_norm_Ad_Z_jap_PPImore) #15
# Adults - Autosomes
ST_norm_Ad_Aut_noint <- subset(ST_norm_Ad_Aut, TotalPPIs_exp=0)
nrow(ST_norm_Ad_Aut_noint) #2134
ST_norm_Ad_Aut_PPI<- subset(ST_norm_Ad_Aut, TotalPPIs_exp>=1 & TotalPPIs_exp<10)
nrow(ST_norm_Ad_Aut_PPI)  #89
ST_norm_Ad_Aut_PPImore<- subset(ST_norm_Ad_Aut, TotalPPIs_exp>=10)
nrow(ST_norm_Ad_Aut_PPImore)  #107
# Schistosomula - S. mansoni
ST_norm_Som_Z_mans_noint <- subset(ST_norm_Som_Z_mans, TotalPPIs_exp=0)
nrow(ST_norm_Som_Z_mans_noint) #375
ST_norm_Som_Z_mans_PPI<- subset(ST_norm_Som_Z_mans, TotalPPIs_exp>=1 & TotalPPIs_exp<10)
nrow(ST_norm_Som_Z_mans_PPI) #15
ST_norm_Som_Z_mans_PPImore<- subset(ST_norm_Som_Z_mans, TotalPPIs_exp>=10)
nrow(ST_norm_Som_Z_mans_PPImore) #17
# Schistosomula - S. japonicum
ST_norm_Som_Z_jap_noint <- subset(ST_norm_Som_Z_jap, TotalPPIs_exp=0)
nrow(ST_norm_Som_Z_jap_noint) #305
ST_norm_Som_Z_jap_PPI<- subset(ST_norm_Som_Z_jap, TotalPPIs_exp>=1 & TotalPPIs_exp<10)
nrow(ST_norm_Som_Z_jap_PPI) #15
ST_norm_Som_Z_jap_PPImore<- subset(ST_norm_Som_Z_jap, TotalPPIs_exp>=10)
nrow(ST_norm_Som_Z_jap_PPImore) #15
# Schistosomula - Autosomes
ST_norm_Som_Aut_noint <- subset(ST_norm_Som_Aut, TotalPPIs_exp=0)
nrow(ST_norm_Som_Aut_noint) #2134
ST_norm_Som_Aut_PPI<- subset(ST_norm_Som_Aut, TotalPPIs_exp>=1 & TotalPPIs_exp<10)
nrow(ST_norm_Som_Aut_PPI) #89
ST_norm_Som_Aut_PPImore<- subset(ST_norm_Som_Aut, TotalPPIs_exp>=10)
nrow(ST_norm_Som_Aut_PPImore) #107

layout(matrix(c(1,1,2,2,3,3,4,4), 2, 4, byrow = TRUE))
par(mar=c(3,5,5,1))
boxplot(ST_norm_Som_Z_jap_noint$FMlog_Som_jap,ST_norm_Som_Aut_noint$FMlog_Som_jap,ST_norm_Som_Z_jap_PPI$FMlog_Som_jap,ST_norm_Som_Aut_PPI$FMlog_Som_jap,ST_norm_Som_Z_jap_PPImore$FMlog_Som_jap,ST_norm_Som_Aut_PPImore$FMlog_Som_jap, names = c("Z","A","Z","A","Z","A"), ylab="log2(F:M)",cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey","sienna1","grey","sienna1","grey"), main="A. S.jap SCHISTOSOMULA")
abline(v = 2.5)
abline(v = 4.5)
boxplot(ST_norm_Ad_Z_jap_noint$FMlog_Ad_jap,ST_norm_Ad_Aut_noint$FMlog_Ad_jap,ST_norm_Ad_Z_jap_PPI$FMlog_Ad_jap,ST_norm_Ad_Aut_PPI$FMlog_Ad_jap,ST_norm_Ad_Z_jap_PPImore$FMlog_Ad_jap,ST_norm_Ad_Aut_PPImore$FMlog_Ad_jap, names = c("Z","A","Z","A","Z","A"), ylab="log2(F:M)",cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey","sienna1","grey","sienna1","grey"), main="B. S.jap ADULTS")
abline(v = 2.5)
abline(v = 4.5)
boxplot(ST_norm_Som_Z_mans_noint$FMlog_Som_mans,ST_norm_Som_Aut_noint$FMlog_Som_mans,ST_norm_Som_Z_mans_PPI$FMlog_Som_mans,ST_norm_Som_Aut_PPI$FMlog_Som_mans,ST_norm_Som_Z_mans_PPImore$FMlog_Som_mans,ST_norm_Som_Aut_PPImore$FMlog_Som_mans, names = c("Z","A","Z","A","Z","A"), ylab="log2(F:M)",cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey","sienna1","grey","sienna1","grey"), main="C. S.mans SCHISTOSOMULA")
abline(v = 2.5)
abline(v = 4.5)
boxplot(ST_norm_Ad_Z_mans_noint$FMlog_Ad_mans,ST_norm_Ad_Aut_noint$FMlog_Ad_mans,ST_norm_Ad_Z_mans_PPI$FMlog_Ad_mans,ST_norm_Ad_Aut_PPI$FMlog_Ad_mans,ST_norm_Ad_Z_mans_PPImore$FMlog_Ad_mans,ST_norm_Ad_Aut_PPImore$FMlog_Ad_mans, names = c("Z","A","Z","A","Z","A"), ylab="log2(F:M)",cex.axis=1, cex.lab=1.5, notch=T, outline = F, col=c("sienna1","grey","sienna1","grey","sienna1","grey"), main="D. S.mans ADULTS")
abline(v = 2.5)
abline(v = 4.5)

wilcox.test(ST_norm_Som_Z_jap_noint$FMratio_Som_jap,ST_norm_Som_Aut_noint$FMratio_Som_jap)$p.value
median(ST_norm_Som_Z_jap_noint$FMratio_Som_jap) / median(ST_norm_Som_Aut_noint$FMratio_Som_jap)
wilcox.test(ST_norm_Som_Z_jap_PPI$FMratio_Som_jap,ST_norm_Som_Aut_PPI$FMratio_Som_jap)$p.value
median(ST_norm_Som_Z_jap_PPI$FMratio_Som_jap) / median(ST_norm_Som_Aut_PPI$FMratio_Som_jap)
wilcox.test(ST_norm_Som_Z_jap_PPImore$FMratio_Som_jap,ST_norm_Som_Aut_PPImore$FMratio_Som_jap)$p.value
median(ST_norm_Som_Z_jap_PPImore$FMratio_Som_jap) / median(ST_norm_Som_Aut_PPImore$FMratio_Som_jap)

wilcox.test(ST_norm_Ad_Z_jap_noint$FMratio_Ad_jap,ST_norm_Ad_Aut_noint$FMratio_Ad_jap)$p.value
median(ST_norm_Ad_Z_jap_noint$FMratio_Ad_jap) / median(ST_norm_Ad_Aut_noint$FMratio_Ad_jap)
wilcox.test(ST_norm_Ad_Z_jap_PPI$FMratio_Ad_jap,ST_norm_Ad_Aut_PPI$FMratio_Ad_jap)$p.value
median(ST_norm_Ad_Z_jap_PPI$FMratio_Ad_jap) / median(ST_norm_Ad_Aut_PPI$FMratio_Ad_jap)
wilcox.test(ST_norm_Ad_Z_jap_PPImore$FMratio_Ad_jap,ST_norm_Ad_Aut_PPImore$FMratio_Ad_jap)$p.value
median(ST_norm_Ad_Z_jap_PPImore$FMratio_Ad_jap) / median(ST_norm_Ad_Aut_PPImore$FMratio_Ad_jap)

wilcox.test(ST_norm_Som_Z_mans_noint$FMratio_Som_mans,ST_norm_Som_Aut_noint$FMratio_Som_mans)$p.value
median(ST_norm_Som_Z_mans_noint$FMratio_Som_mans) / median(ST_norm_Som_Aut_noint$FMratio_Som_mans)
wilcox.test(ST_norm_Som_Z_mans_PPI$FMratio_Som_mans,ST_norm_Som_Aut_PPI$FMratio_Som_mans)$p.value
median(ST_norm_Som_Z_mans_PPI$FMratio_Som_mans) / median(ST_norm_Som_Aut_PPI$FMratio_Som_mans)
wilcox.test(ST_norm_Som_Z_mans_PPImore$FMratio_Som_mans,ST_norm_Som_Aut_PPImore$FMratio_Som_mans)$p.value
median(ST_norm_Som_Z_mans_PPImore$FMratio_Som_mans) / median(ST_norm_Som_Aut_PPImore$FMratio_Som_mans)

wilcox.test(ST_norm_Ad_Z_mans_noint$FMratio_Ad_mans,ST_norm_Ad_Aut_noint$FMratio_Ad_mans)$p.value
median(ST_norm_Ad_Z_mans_noint$FMratio_Ad_mans) / median(ST_norm_Ad_Aut_noint$FMratio_Ad_mans)
wilcox.test(ST_norm_Ad_Z_mans_PPI$FMratio_Ad_mans,ST_norm_Ad_Aut_PPI$FMratio_Ad_mans)$p.value
median(ST_norm_Ad_Z_mans_PPI$FMratio_Ad_mans) / median(ST_norm_Ad_Aut_PPI$FMratio_Ad_mans)
wilcox.test(ST_norm_Ad_Z_mans_PPImore$FMratio_Ad_mans,ST_norm_Ad_Aut_PPImore$FMratio_Ad_mans)$p.value
median(ST_norm_Ad_Z_mans_PPImore$FMratio_Ad_mans) / median(ST_norm_Ad_Aut_PPImore$FMratio_Ad_mans)

